import { defineComponent as jt, ref as We, onMounted as po, onUnmounted as mo, computed as It, watch as Ft, toRefs as vo, openBlock as Lt, createElementBlock as Ht, createElementVNode as rt, normalizeStyle as yo, withDirectives as go, vShow as wo, renderSlot as Mr, withModifiers as nt } from "vue";
var Ar = (r, o, i) => {
  if (!o.has(r))
    throw TypeError("Cannot " + i);
}, Cr = (r, o, i) => (Ar(r, o, "read from private field"), i ? i.call(r) : o.get(r)), bo = (r, o, i) => {
  if (o.has(r))
    throw TypeError("Cannot add the same private member more than once");
  o instanceof WeakSet ? o.add(r) : o.set(r, i);
}, Co = (r, o, i, c) => (Ar(r, o, "write to private field"), c ? c.call(r, i) : o.set(r, i), i);
const Dr = [
  ["aztec", "Aztec"],
  ["code_128", "Code128"],
  ["code_39", "Code39"],
  ["code_93", "Code93"],
  ["codabar", "Codabar"],
  ["databar", "DataBar"],
  ["databar_expanded", "DataBarExpanded"],
  ["data_matrix", "DataMatrix"],
  ["dx_film_edge", "DXFilmEdge"],
  ["ean_13", "EAN-13"],
  ["ean_8", "EAN-8"],
  ["itf", "ITF"],
  ["maxi_code", "MaxiCode"],
  ["micro_qr_code", "MicroQRCode"],
  ["pdf417", "PDF417"],
  ["qr_code", "QRCode"],
  ["rm_qr_code", "rMQRCode"],
  ["upc_a", "UPC-A"],
  ["upc_e", "UPC-E"],
  ["linear_codes", "Linear-Codes"],
  ["matrix_codes", "Matrix-Codes"]
], $o = [...Dr, ["unknown"]].map((r) => r[0]), ot = new Map(
  Dr
);
function _o(r) {
  for (const [o, i] of ot)
    if (r === i)
      return o;
  return "unknown";
}
function So(r) {
  if (Rr(r))
    return {
      width: r.naturalWidth,
      height: r.naturalHeight
    };
  if (xr(r))
    return {
      width: r.width.baseVal.value,
      height: r.height.baseVal.value
    };
  if (kr(r))
    return {
      width: r.videoWidth,
      height: r.videoHeight
    };
  if (Fr(r))
    return {
      width: r.width,
      height: r.height
    };
  if (Wr(r))
    return {
      width: r.displayWidth,
      height: r.displayHeight
    };
  if (Ir(r))
    return {
      width: r.width,
      height: r.height
    };
  if (Ur(r))
    return {
      width: r.width,
      height: r.height
    };
  throw new TypeError(
    "The provided value is not of type '(Blob or HTMLCanvasElement or HTMLImageElement or HTMLVideoElement or ImageBitmap or ImageData or OffscreenCanvas or SVGImageElement or VideoFrame)'."
  );
}
function Rr(r) {
  try {
    return r instanceof HTMLImageElement;
  } catch (o) {
    return !1;
  }
}
function xr(r) {
  try {
    return r instanceof SVGImageElement;
  } catch (o) {
    return !1;
  }
}
function kr(r) {
  try {
    return r instanceof HTMLVideoElement;
  } catch (o) {
    return !1;
  }
}
function Ir(r) {
  try {
    return r instanceof HTMLCanvasElement;
  } catch (o) {
    return !1;
  }
}
function Fr(r) {
  try {
    return r instanceof ImageBitmap;
  } catch (o) {
    return !1;
  }
}
function Ur(r) {
  try {
    return r instanceof OffscreenCanvas;
  } catch (o) {
    return !1;
  }
}
function Wr(r) {
  try {
    return r instanceof VideoFrame;
  } catch (o) {
    return !1;
  }
}
function jr(r) {
  try {
    return r instanceof Blob;
  } catch (o) {
    return !1;
  }
}
function Po(r) {
  try {
    return r instanceof ImageData;
  } catch (o) {
    return !1;
  }
}
function To(r, o) {
  try {
    const i = new OffscreenCanvas(r, o);
    if (i.getContext("2d") instanceof OffscreenCanvasRenderingContext2D)
      return i;
    throw void 0;
  } catch (i) {
    const c = document.createElement("canvas");
    return c.width = r, c.height = o, c;
  }
}
async function Lr(r) {
  if (Rr(r) && !await Ao(r))
    throw new DOMException(
      "Failed to load or decode HTMLImageElement.",
      "InvalidStateError"
    );
  if (xr(r) && !await Do(r))
    throw new DOMException(
      "Failed to load or decode SVGImageElement.",
      "InvalidStateError"
    );
  if (Wr(r) && Ro(r))
    throw new DOMException("VideoFrame is closed.", "InvalidStateError");
  if (kr(r) && (r.readyState === 0 || r.readyState === 1))
    throw new DOMException("Invalid element or state.", "InvalidStateError");
  if (Fr(r) && ko(r))
    throw new DOMException(
      "The image source is detached.",
      "InvalidStateError"
    );
  const { width: o, height: i } = So(r);
  if (o === 0 || i === 0)
    return null;
  const c = To(o, i).getContext("2d");
  c.drawImage(r, 0, 0);
  try {
    return c.getImageData(0, 0, o, i);
  } catch (l) {
    throw new DOMException("Source would taint origin.", "SecurityError");
  }
}
async function Eo(r) {
  let o;
  try {
    if (globalThis.createImageBitmap)
      o = await createImageBitmap(r);
    else if (globalThis.Image) {
      o = new Image();
      let i = "";
      try {
        i = URL.createObjectURL(r), o.src = i, await o.decode();
      } finally {
        URL.revokeObjectURL(i);
      }
    } else
      return r;
  } catch (i) {
    throw new DOMException(
      "Failed to load or decode Blob.",
      "InvalidStateError"
    );
  }
  return await Lr(o);
}
function Oo(r) {
  const { width: o, height: i } = r;
  if (o === 0 || i === 0)
    return null;
  const c = r.getContext("2d");
  try {
    return c.getImageData(0, 0, o, i);
  } catch (l) {
    throw new DOMException("Source would taint origin.", "SecurityError");
  }
}
async function Mo(r) {
  if (jr(r))
    return await Eo(r);
  if (Po(r)) {
    if (xo(r))
      throw new DOMException(
        "The image data has been detached.",
        "InvalidStateError"
      );
    return r;
  }
  return Ir(r) || Ur(r) ? Oo(r) : await Lr(r);
}
async function Ao(r) {
  try {
    return await r.decode(), !0;
  } catch (o) {
    return !1;
  }
}
async function Do(r) {
  var o;
  try {
    return await ((o = r.decode) == null ? void 0 : o.call(r)), !0;
  } catch (i) {
    return !1;
  }
}
function Ro(r) {
  return r.format === null;
}
function xo(r) {
  return r.data.buffer.byteLength === 0;
}
function ko(r) {
  return r.width === 0 && r.height === 0;
}
function $r(r, o) {
  return r instanceof DOMException ? new DOMException(`${o}: ${r.message}`, r.name) : r instanceof Error ? new r.constructor(`${o}: ${r.message}`) : new Error(`${o}: ${r}`);
}
const _r = [
  "Aztec",
  "Codabar",
  "Code128",
  "Code39",
  "Code93",
  "DataBar",
  "DataBarExpanded",
  "DataMatrix",
  "DXFilmEdge",
  "EAN-13",
  "EAN-8",
  "ITF",
  "Linear-Codes",
  "Matrix-Codes",
  "MaxiCode",
  "MicroQRCode",
  "None",
  "PDF417",
  "QRCode",
  "rMQRCode",
  "UPC-A",
  "UPC-E"
];
function Io(r) {
  return r.join("|");
}
function Fo(r) {
  const o = Sr(r);
  let i = 0, c = _r.length - 1;
  for (; i <= c; ) {
    const l = Math.floor((i + c) / 2), h = _r[l], v = Sr(h);
    if (v === o)
      return h;
    v < o ? i = l + 1 : c = l - 1;
  }
  return "None";
}
function Sr(r) {
  return r.toLowerCase().replace(/_-\[\]/g, "");
}
function Uo(r, o) {
  return r.Binarizer[o];
}
function Wo(r, o) {
  return r.CharacterSet[o];
}
const jo = [
  "Text",
  "Binary",
  "Mixed",
  "GS1",
  "ISO15434",
  "UnknownECI"
];
function Lo(r) {
  return jo[r.value];
}
function Ho(r, o) {
  return r.EanAddOnSymbol[o];
}
function Bo(r, o) {
  return r.TextMode[o];
}
const Te = {
  formats: [],
  tryHarder: !0,
  tryRotate: !0,
  tryInvert: !0,
  tryDownscale: !0,
  binarizer: "LocalAverage",
  isPure: !1,
  downscaleFactor: 3,
  downscaleThreshold: 500,
  minLineCount: 2,
  maxNumberOfSymbols: 255,
  tryCode39ExtendedMode: !1,
  validateCode39CheckSum: !1,
  validateITFCheckSum: !1,
  returnCodabarStartEnd: !1,
  returnErrors: !1,
  eanAddOnSymbol: "Read",
  textMode: "Plain",
  characterSet: "Unknown"
};
function Hr(r, o) {
  return {
    ...o,
    formats: Io(o.formats),
    binarizer: Uo(r, o.binarizer),
    eanAddOnSymbol: Ho(
      r,
      o.eanAddOnSymbol
    ),
    textMode: Bo(r, o.textMode),
    characterSet: Wo(
      r,
      o.characterSet
    )
  };
}
function Br(r) {
  return {
    ...r,
    format: Fo(r.format),
    eccLevel: r.eccLevel,
    contentType: Lo(r.contentType)
  };
}
const Vo = {
  locateFile: (r, o) => {
    const i = r.match(/_(.+?)\.wasm$/);
    return i ? `https://fastly.jsdelivr.net/npm/zxing-wasm@1.1.3/dist/${i[1]}/${r}` : o + r;
  }
};
let Ut = /* @__PURE__ */ new WeakMap();
function Bt(r, o) {
  var i;
  const c = Ut.get(r);
  if (c != null && c.modulePromise && (o === void 0 || Object.is(o, c.moduleOverrides)))
    return c.modulePromise;
  const l = (i = o != null ? o : c == null ? void 0 : c.moduleOverrides) != null ? i : Vo, h = r({
    ...l
  });
  return Ut.set(r, {
    moduleOverrides: l,
    modulePromise: h
  }), h;
}
function zo(r, o) {
  Ut.set(r, {
    moduleOverrides: o
  });
}
async function Go(r, o, i = Te) {
  const c = {
    ...Te,
    ...i
  }, l = await Bt(r), { size: h } = o, v = new Uint8Array(await o.arrayBuffer()), g = l._malloc(h);
  l.HEAPU8.set(v, g);
  const b = l.readBarcodesFromImage(
    g,
    h,
    Hr(l, c)
  );
  l._free(g);
  const p = [];
  for (let _ = 0; _ < b.size(); ++_)
    p.push(
      Br(b.get(_))
    );
  return p;
}
async function qo(r, o, i = Te) {
  const c = {
    ...Te,
    ...i
  }, l = await Bt(r), {
    data: h,
    width: v,
    height: g,
    data: { byteLength: b }
  } = o, p = l._malloc(b);
  l.HEAPU8.set(h, p);
  const _ = l.readBarcodesFromPixmap(
    p,
    v,
    g,
    Hr(l, c)
  );
  l._free(p);
  const S = [];
  for (let C = 0; C < _.size(); ++C)
    S.push(
      Br(_.get(C))
    );
  return S;
}
({
  ...Te,
  formats: [...Te.formats]
});
var ct = (() => {
  var r = typeof document < "u" && document.currentScript ? document.currentScript.src : void 0;
  return function(o = {}) {
    var i = o, c, l;
    i.ready = new Promise((e, t) => {
      c = e, l = t;
    });
    var h = Object.assign({}, i), v = "./this.program", g = typeof window == "object", b = typeof importScripts == "function";
    typeof process == "object" && typeof process.versions == "object" && process.versions.node;
    var p = "";
    function _(e) {
      return i.locateFile ? i.locateFile(e, p) : p + e;
    }
    var S;
    (g || b) && (b ? p = self.location.href : typeof document < "u" && document.currentScript && (p = document.currentScript.src), r && (p = r), p.indexOf("blob:") !== 0 ? p = p.substr(0, p.replace(/[?#].*/, "").lastIndexOf("/") + 1) : p = "", b && (S = (e) => {
      var t = new XMLHttpRequest();
      return t.open("GET", e, !1), t.responseType = "arraybuffer", t.send(null), new Uint8Array(t.response);
    })), i.print || console.log.bind(console);
    var C = i.printErr || console.error.bind(console);
    Object.assign(i, h), h = null, i.arguments && i.arguments, i.thisProgram && (v = i.thisProgram), i.quit && i.quit;
    var W;
    i.wasmBinary && (W = i.wasmBinary), typeof WebAssembly != "object" && be("no native wasm support detected");
    var F, j = !1, M, x, k, U, A, R, ae, ge;
    function we() {
      var e = F.buffer;
      i.HEAP8 = M = new Int8Array(e), i.HEAP16 = k = new Int16Array(e), i.HEAPU8 = x = new Uint8Array(e), i.HEAPU16 = U = new Uint16Array(e), i.HEAP32 = A = new Int32Array(e), i.HEAPU32 = R = new Uint32Array(e), i.HEAPF32 = ae = new Float32Array(e), i.HEAPF64 = ge = new Float64Array(e);
    }
    var Ee = [], Oe = [], Me = [];
    function lt() {
      if (i.preRun)
        for (typeof i.preRun == "function" && (i.preRun = [i.preRun]); i.preRun.length; )
          ht(i.preRun.shift());
      vt(Ee);
    }
    function dt() {
      vt(Oe);
    }
    function ft() {
      if (i.postRun)
        for (typeof i.postRun == "function" && (i.postRun = [i.postRun]); i.postRun.length; )
          Le(i.postRun.shift());
      vt(Me);
    }
    function ht(e) {
      Ee.unshift(e);
    }
    function Ae(e) {
      Oe.unshift(e);
    }
    function Le(e) {
      Me.unshift(e);
    }
    var oe = 0, me = null;
    function le(e) {
      var t;
      oe++, (t = i.monitorRunDependencies) === null || t === void 0 || t.call(i, oe);
    }
    function ee(e) {
      var t;
      if (oe--, (t = i.monitorRunDependencies) === null || t === void 0 || t.call(i, oe), oe == 0 && me) {
        var n = me;
        me = null, n();
      }
    }
    function be(e) {
      var t;
      (t = i.onAbort) === null || t === void 0 || t.call(i, e), e = "Aborted(" + e + ")", C(e), j = !0, e += ". Build with -sASSERTIONS for more info.";
      var n = new WebAssembly.RuntimeError(e);
      throw l(n), n;
    }
    var pt = "data:application/octet-stream;base64,", He = (e) => e.startsWith(pt), de;
    de = "zxing_reader.wasm", He(de) || (de = _(de));
    function Be(e) {
      if (e == de && W)
        return new Uint8Array(W);
      if (S)
        return S(e);
      throw "both async and sync fetching of the wasm failed";
    }
    function mt(e) {
      return !W && (g || b) && typeof fetch == "function" ? fetch(e, {
        credentials: "same-origin"
      }).then((t) => {
        if (!t.ok)
          throw "failed to load wasm binary file at '" + e + "'";
        return t.arrayBuffer();
      }).catch(() => Be(e)) : Promise.resolve().then(() => Be(e));
    }
    function zt(e, t, n) {
      return mt(e).then((a) => WebAssembly.instantiate(a, t)).then((a) => a).then(n, (a) => {
        C(`failed to asynchronously prepare wasm: ${a}`), be(a);
      });
    }
    function rn(e, t, n, a) {
      return !e && typeof WebAssembly.instantiateStreaming == "function" && !He(t) && typeof fetch == "function" ? fetch(t, {
        credentials: "same-origin"
      }).then((s) => {
        var u = WebAssembly.instantiateStreaming(s, n);
        return u.then(a, function(d) {
          return C(`wasm streaming compile failed: ${d}`), C("falling back to ArrayBuffer instantiation"), zt(t, n, a);
        });
      }) : zt(t, n, a);
    }
    function nn() {
      var e = {
        a: Ga
      };
      function t(a, s) {
        return N = a.exports, F = N.ia, we(), er = N.ma, Ae(N.ja), ee(), N;
      }
      le();
      function n(a) {
        t(a.instance);
      }
      if (i.instantiateWasm)
        try {
          return i.instantiateWasm(e, t);
        } catch (a) {
          C(`Module.instantiateWasm callback failed with error: ${a}`), l(a);
        }
      return rn(W, de, e, n).catch(l), {};
    }
    var vt = (e) => {
      for (; e.length > 0; )
        e.shift()(i);
    };
    i.noExitRuntime;
    var Ve = [], ze = 0, an = (e) => {
      var t = new yt(e);
      return t.get_caught() || (t.set_caught(!0), ze--), t.set_rethrown(!1), Ve.push(t), pr(t.excPtr), t.get_exception_ptr();
    }, ie = 0, on = () => {
      L(0, 0);
      var e = Ve.pop();
      hr(e.excPtr), ie = 0;
    };
    function yt(e) {
      this.excPtr = e, this.ptr = e - 24, this.set_type = function(t) {
        R[this.ptr + 4 >> 2] = t;
      }, this.get_type = function() {
        return R[this.ptr + 4 >> 2];
      }, this.set_destructor = function(t) {
        R[this.ptr + 8 >> 2] = t;
      }, this.get_destructor = function() {
        return R[this.ptr + 8 >> 2];
      }, this.set_caught = function(t) {
        t = t ? 1 : 0, M[this.ptr + 12 >> 0] = t;
      }, this.get_caught = function() {
        return M[this.ptr + 12 >> 0] != 0;
      }, this.set_rethrown = function(t) {
        t = t ? 1 : 0, M[this.ptr + 13 >> 0] = t;
      }, this.get_rethrown = function() {
        return M[this.ptr + 13 >> 0] != 0;
      }, this.init = function(t, n) {
        this.set_adjusted_ptr(0), this.set_type(t), this.set_destructor(n);
      }, this.set_adjusted_ptr = function(t) {
        R[this.ptr + 16 >> 2] = t;
      }, this.get_adjusted_ptr = function() {
        return R[this.ptr + 16 >> 2];
      }, this.get_exception_ptr = function() {
        var t = vr(this.get_type());
        if (t)
          return R[this.excPtr >> 2];
        var n = this.get_adjusted_ptr();
        return n !== 0 ? n : this.excPtr;
      };
    }
    var sn = (e) => {
      throw ie || (ie = e), ie;
    }, gt = (e) => {
      var t = ie;
      if (!t)
        return Ue(0), 0;
      var n = new yt(t);
      n.set_adjusted_ptr(t);
      var a = n.get_type();
      if (!a)
        return Ue(0), t;
      for (var s in e) {
        var u = e[s];
        if (u === 0 || u === a)
          break;
        var d = n.ptr + 16;
        if (mr(u, a, d))
          return Ue(u), t;
      }
      return Ue(a), t;
    }, cn = () => gt([]), un = (e) => gt([e]), ln = (e, t) => gt([e, t]), dn = () => {
      var e = Ve.pop();
      e || be("no exception to throw");
      var t = e.excPtr;
      throw e.get_rethrown() || (Ve.push(e), e.set_rethrown(!0), e.set_caught(!1), ze++), ie = t, ie;
    }, fn = (e, t, n) => {
      var a = new yt(e);
      throw a.init(t, n), ie = e, ze++, ie;
    }, hn = () => ze, Ge = {}, wt = (e) => {
      for (; e.length; ) {
        var t = e.pop(), n = e.pop();
        n(t);
      }
    };
    function bt(e) {
      return this.fromWireType(A[e >> 2]);
    }
    var Ce = {}, ve = {}, qe = {}, Gt, Ne = (e) => {
      throw new Gt(e);
    }, ye = (e, t, n) => {
      e.forEach(function(f) {
        qe[f] = t;
      });
      function a(f) {
        var m = n(f);
        m.length !== e.length && Ne("Mismatched type converter count");
        for (var w = 0; w < e.length; ++w)
          te(e[w], m[w]);
      }
      var s = new Array(t.length), u = [], d = 0;
      t.forEach((f, m) => {
        ve.hasOwnProperty(f) ? s[m] = ve[f] : (u.push(f), Ce.hasOwnProperty(f) || (Ce[f] = []), Ce[f].push(() => {
          s[m] = ve[f], ++d, d === u.length && a(s);
        }));
      }), u.length === 0 && a(s);
    }, pn = (e) => {
      var t = Ge[e];
      delete Ge[e];
      var n = t.rawConstructor, a = t.rawDestructor, s = t.fields, u = s.map((d) => d.getterReturnType).concat(s.map((d) => d.setterArgumentType));
      ye([e], u, (d) => {
        var f = {};
        return s.forEach((m, w) => {
          var $ = m.fieldName, T = d[w], E = m.getter, O = m.getterContext, H = d[w + s.length], G = m.setter, I = m.setterContext;
          f[$] = {
            read: (Q) => T.fromWireType(E(O, Q)),
            write: (Q, y) => {
              var P = [];
              G(I, Q, H.toWireType(P, y)), wt(P);
            }
          };
        }), [{
          name: t.name,
          fromWireType: (m) => {
            var w = {};
            for (var $ in f)
              w[$] = f[$].read(m);
            return a(m), w;
          },
          toWireType: (m, w) => {
            for (var $ in f)
              if (!($ in w))
                throw new TypeError(`Missing field: "${$}"`);
            var T = n();
            for ($ in f)
              f[$].write(T, w[$]);
            return m !== null && m.push(a, T), T;
          },
          argPackAdvance: re,
          readValueFromPointer: bt,
          destructorFunction: a
        }];
      });
    }, mn = (e, t, n, a, s) => {
    }, vn = () => {
      for (var e = new Array(256), t = 0; t < 256; ++t)
        e[t] = String.fromCharCode(t);
      qt = e;
    }, qt, J = (e) => {
      for (var t = "", n = e; x[n]; )
        t += qt[x[n++]];
      return t;
    }, $e, D = (e) => {
      throw new $e(e);
    };
    function yn(e, t) {
      let n = arguments.length > 2 && arguments[2] !== void 0 ? arguments[2] : {};
      var a = t.name;
      if (e || D(`type "${a}" must have a positive integer typeid pointer`), ve.hasOwnProperty(e)) {
        if (n.ignoreDuplicateRegistrations)
          return;
        D(`Cannot register type '${a}' twice`);
      }
      if (ve[e] = t, delete qe[e], Ce.hasOwnProperty(e)) {
        var s = Ce[e];
        delete Ce[e], s.forEach((u) => u());
      }
    }
    function te(e, t) {
      let n = arguments.length > 2 && arguments[2] !== void 0 ? arguments[2] : {};
      if (!("argPackAdvance" in t))
        throw new TypeError("registerType registeredInstance requires argPackAdvance");
      return yn(e, t, n);
    }
    var re = 8, gn = (e, t, n, a) => {
      t = J(t), te(e, {
        name: t,
        fromWireType: function(s) {
          return !!s;
        },
        toWireType: function(s, u) {
          return u ? n : a;
        },
        argPackAdvance: re,
        readValueFromPointer: function(s) {
          return this.fromWireType(x[s]);
        },
        destructorFunction: null
      });
    }, wn = (e) => ({
      count: e.count,
      deleteScheduled: e.deleteScheduled,
      preservePointerOnDelete: e.preservePointerOnDelete,
      ptr: e.ptr,
      ptrType: e.ptrType,
      smartPtr: e.smartPtr,
      smartPtrType: e.smartPtrType
    }), Ct = (e) => {
      function t(n) {
        return n.$$.ptrType.registeredClass.name;
      }
      D(t(e) + " instance already deleted");
    }, $t = !1, Nt = (e) => {
    }, bn = (e) => {
      e.smartPtr ? e.smartPtrType.rawDestructor(e.smartPtr) : e.ptrType.registeredClass.rawDestructor(e.ptr);
    }, Yt = (e) => {
      e.count.value -= 1;
      var t = e.count.value === 0;
      t && bn(e);
    }, Jt = (e, t, n) => {
      if (t === n)
        return e;
      if (n.baseClass === void 0)
        return null;
      var a = Jt(e, t, n.baseClass);
      return a === null ? null : n.downcast(a);
    }, Qt = {}, Cn = () => Object.keys(xe).length, $n = () => {
      var e = [];
      for (var t in xe)
        xe.hasOwnProperty(t) && e.push(xe[t]);
      return e;
    }, De = [], _t = () => {
      for (; De.length; ) {
        var e = De.pop();
        e.$$.deleteScheduled = !1, e.delete();
      }
    }, Re, _n = (e) => {
      Re = e, De.length && Re && Re(_t);
    }, Sn = () => {
      i.getInheritedInstanceCount = Cn, i.getLiveInheritedInstances = $n, i.flushPendingDeletes = _t, i.setDelayFunction = _n;
    }, xe = {}, Pn = (e, t) => {
      for (t === void 0 && D("ptr should not be undefined"); e.baseClass; )
        t = e.upcast(t), e = e.baseClass;
      return t;
    }, Tn = (e, t) => (t = Pn(e, t), xe[t]), Ye = (e, t) => {
      (!t.ptrType || !t.ptr) && Ne("makeClassHandle requires ptr and ptrType");
      var n = !!t.smartPtrType, a = !!t.smartPtr;
      return n !== a && Ne("Both smartPtrType and smartPtr must be specified"), t.count = {
        value: 1
      }, ke(Object.create(e, {
        $$: {
          value: t,
          writable: !0
        }
      }));
    };
    function En(e) {
      var t = this.getPointee(e);
      if (!t)
        return this.destructor(e), null;
      var n = Tn(this.registeredClass, t);
      if (n !== void 0) {
        if (n.$$.count.value === 0)
          return n.$$.ptr = t, n.$$.smartPtr = e, n.clone();
        var a = n.clone();
        return this.destructor(e), a;
      }
      function s() {
        return this.isSmartPointer ? Ye(this.registeredClass.instancePrototype, {
          ptrType: this.pointeeType,
          ptr: t,
          smartPtrType: this,
          smartPtr: e
        }) : Ye(this.registeredClass.instancePrototype, {
          ptrType: this,
          ptr: e
        });
      }
      var u = this.registeredClass.getActualType(t), d = Qt[u];
      if (!d)
        return s.call(this);
      var f;
      this.isConst ? f = d.constPointerType : f = d.pointerType;
      var m = Jt(t, this.registeredClass, f.registeredClass);
      return m === null ? s.call(this) : this.isSmartPointer ? Ye(f.registeredClass.instancePrototype, {
        ptrType: f,
        ptr: m,
        smartPtrType: this,
        smartPtr: e
      }) : Ye(f.registeredClass.instancePrototype, {
        ptrType: f,
        ptr: m
      });
    }
    var ke = (e) => typeof FinalizationRegistry > "u" ? (ke = (t) => t, e) : ($t = new FinalizationRegistry((t) => {
      Yt(t.$$);
    }), ke = (t) => {
      var n = t.$$, a = !!n.smartPtr;
      if (a) {
        var s = {
          $$: n
        };
        $t.register(t, s, t);
      }
      return t;
    }, Nt = (t) => $t.unregister(t), ke(e)), On = () => {
      Object.assign(Je.prototype, {
        isAliasOf(e) {
          if (!(this instanceof Je) || !(e instanceof Je))
            return !1;
          var t = this.$$.ptrType.registeredClass, n = this.$$.ptr;
          e.$$ = e.$$;
          for (var a = e.$$.ptrType.registeredClass, s = e.$$.ptr; t.baseClass; )
            n = t.upcast(n), t = t.baseClass;
          for (; a.baseClass; )
            s = a.upcast(s), a = a.baseClass;
          return t === a && n === s;
        },
        clone() {
          if (this.$$.ptr || Ct(this), this.$$.preservePointerOnDelete)
            return this.$$.count.value += 1, this;
          var e = ke(Object.create(Object.getPrototypeOf(this), {
            $$: {
              value: wn(this.$$)
            }
          }));
          return e.$$.count.value += 1, e.$$.deleteScheduled = !1, e;
        },
        delete() {
          this.$$.ptr || Ct(this), this.$$.deleteScheduled && !this.$$.preservePointerOnDelete && D("Object already scheduled for deletion"), Nt(this), Yt(this.$$), this.$$.preservePointerOnDelete || (this.$$.smartPtr = void 0, this.$$.ptr = void 0);
        },
        isDeleted() {
          return !this.$$.ptr;
        },
        deleteLater() {
          return this.$$.ptr || Ct(this), this.$$.deleteScheduled && !this.$$.preservePointerOnDelete && D("Object already scheduled for deletion"), De.push(this), De.length === 1 && Re && Re(_t), this.$$.deleteScheduled = !0, this;
        }
      });
    };
    function Je() {
    }
    var Ie = (e, t) => Object.defineProperty(t, "name", {
      value: e
    }), Xt = (e, t, n) => {
      if (e[t].overloadTable === void 0) {
        var a = e[t];
        e[t] = function() {
          return e[t].overloadTable.hasOwnProperty(arguments.length) || D(`Function '${n}' called with an invalid number of arguments (${arguments.length}) - expects one of (${e[t].overloadTable})!`), e[t].overloadTable[arguments.length].apply(this, arguments);
        }, e[t].overloadTable = [], e[t].overloadTable[a.argCount] = a;
      }
    }, St = (e, t, n) => {
      i.hasOwnProperty(e) ? ((n === void 0 || i[e].overloadTable !== void 0 && i[e].overloadTable[n] !== void 0) && D(`Cannot register public name '${e}' twice`), Xt(i, e, e), i.hasOwnProperty(n) && D(`Cannot register multiple overloads of a function with the same number of arguments (${n})!`), i[e].overloadTable[n] = t) : (i[e] = t, n !== void 0 && (i[e].numArguments = n));
    }, Mn = 48, An = 57, Dn = (e) => {
      if (e === void 0)
        return "_unknown";
      e = e.replace(/[^a-zA-Z0-9_]/g, "$");
      var t = e.charCodeAt(0);
      return t >= Mn && t <= An ? `_${e}` : e;
    };
    function Rn(e, t, n, a, s, u, d, f) {
      this.name = e, this.constructor = t, this.instancePrototype = n, this.rawDestructor = a, this.baseClass = s, this.getActualType = u, this.upcast = d, this.downcast = f, this.pureVirtualFunctions = [];
    }
    var Pt = (e, t, n) => {
      for (; t !== n; )
        t.upcast || D(`Expected null or instance of ${n.name}, got an instance of ${t.name}`), e = t.upcast(e), t = t.baseClass;
      return e;
    };
    function xn(e, t) {
      if (t === null)
        return this.isReference && D(`null is not a valid ${this.name}`), 0;
      t.$$ || D(`Cannot pass "${At(t)}" as a ${this.name}`), t.$$.ptr || D(`Cannot pass deleted object as a pointer of type ${this.name}`);
      var n = t.$$.ptrType.registeredClass, a = Pt(t.$$.ptr, n, this.registeredClass);
      return a;
    }
    function kn(e, t) {
      var n;
      if (t === null)
        return this.isReference && D(`null is not a valid ${this.name}`), this.isSmartPointer ? (n = this.rawConstructor(), e !== null && e.push(this.rawDestructor, n), n) : 0;
      (!t || !t.$$) && D(`Cannot pass "${At(t)}" as a ${this.name}`), t.$$.ptr || D(`Cannot pass deleted object as a pointer of type ${this.name}`), !this.isConst && t.$$.ptrType.isConst && D(`Cannot convert argument of type ${t.$$.smartPtrType ? t.$$.smartPtrType.name : t.$$.ptrType.name} to parameter type ${this.name}`);
      var a = t.$$.ptrType.registeredClass;
      if (n = Pt(t.$$.ptr, a, this.registeredClass), this.isSmartPointer)
        switch (t.$$.smartPtr === void 0 && D("Passing raw pointer to smart pointer is illegal"), this.sharingPolicy) {
          case 0:
            t.$$.smartPtrType === this ? n = t.$$.smartPtr : D(`Cannot convert argument of type ${t.$$.smartPtrType ? t.$$.smartPtrType.name : t.$$.ptrType.name} to parameter type ${this.name}`);
            break;
          case 1:
            n = t.$$.smartPtr;
            break;
          case 2:
            if (t.$$.smartPtrType === this)
              n = t.$$.smartPtr;
            else {
              var s = t.clone();
              n = this.rawShare(n, se.toHandle(() => s.delete())), e !== null && e.push(this.rawDestructor, n);
            }
            break;
          default:
            D("Unsupporting sharing policy");
        }
      return n;
    }
    function In(e, t) {
      if (t === null)
        return this.isReference && D(`null is not a valid ${this.name}`), 0;
      t.$$ || D(`Cannot pass "${At(t)}" as a ${this.name}`), t.$$.ptr || D(`Cannot pass deleted object as a pointer of type ${this.name}`), t.$$.ptrType.isConst && D(`Cannot convert argument of type ${t.$$.ptrType.name} to parameter type ${this.name}`);
      var n = t.$$.ptrType.registeredClass, a = Pt(t.$$.ptr, n, this.registeredClass);
      return a;
    }
    function Zt(e) {
      return this.fromWireType(R[e >> 2]);
    }
    var Fn = () => {
      Object.assign(Qe.prototype, {
        getPointee(e) {
          return this.rawGetPointee && (e = this.rawGetPointee(e)), e;
        },
        destructor(e) {
          var t;
          (t = this.rawDestructor) === null || t === void 0 || t.call(this, e);
        },
        argPackAdvance: re,
        readValueFromPointer: Zt,
        deleteObject(e) {
          e !== null && e.delete();
        },
        fromWireType: En
      });
    };
    function Qe(e, t, n, a, s, u, d, f, m, w, $) {
      this.name = e, this.registeredClass = t, this.isReference = n, this.isConst = a, this.isSmartPointer = s, this.pointeeType = u, this.sharingPolicy = d, this.rawGetPointee = f, this.rawConstructor = m, this.rawShare = w, this.rawDestructor = $, !s && t.baseClass === void 0 ? a ? (this.toWireType = xn, this.destructorFunction = null) : (this.toWireType = In, this.destructorFunction = null) : this.toWireType = kn;
    }
    var Kt = (e, t, n) => {
      i.hasOwnProperty(e) || Ne("Replacing nonexistant public symbol"), i[e].overloadTable !== void 0 && n !== void 0 ? i[e].overloadTable[n] = t : (i[e] = t, i[e].argCount = n);
    }, Un = (e, t, n) => {
      var a = i["dynCall_" + e];
      return n && n.length ? a.apply(null, [t].concat(n)) : a.call(null, t);
    }, Xe = [], er, B = (e) => {
      var t = Xe[e];
      return t || (e >= Xe.length && (Xe.length = e + 1), Xe[e] = t = er.get(e)), t;
    }, Wn = (e, t, n) => {
      if (e.includes("j"))
        return Un(e, t, n);
      var a = B(t).apply(null, n);
      return a;
    }, jn = (e, t) => {
      var n = [];
      return function() {
        return n.length = 0, Object.assign(n, arguments), Wn(e, t, n);
      };
    }, K = (e, t) => {
      e = J(e);
      function n() {
        return e.includes("j") ? jn(e, t) : B(t);
      }
      var a = n();
      return typeof a != "function" && D(`unknown function pointer with signature ${e}: ${t}`), a;
    }, Ln = (e, t) => {
      var n = Ie(t, function(a) {
        this.name = t, this.message = a;
        var s = new Error(a).stack;
        s !== void 0 && (this.stack = this.toString() + `
` + s.replace(/^Error(:[^\n]*)?\n/, ""));
      });
      return n.prototype = Object.create(e.prototype), n.prototype.constructor = n, n.prototype.toString = function() {
        return this.message === void 0 ? this.name : `${this.name}: ${this.message}`;
      }, n;
    }, tr, rr = (e) => {
      var t = fr(e), n = J(t);
      return ce(t), n;
    }, Ze = (e, t) => {
      var n = [], a = {};
      function s(u) {
        if (!a[u] && !ve[u]) {
          if (qe[u]) {
            qe[u].forEach(s);
            return;
          }
          n.push(u), a[u] = !0;
        }
      }
      throw t.forEach(s), new tr(`${e}: ` + n.map(rr).join([", "]));
    }, Hn = (e, t, n, a, s, u, d, f, m, w, $, T, E) => {
      $ = J($), u = K(s, u), f && (f = K(d, f)), w && (w = K(m, w)), E = K(T, E);
      var O = Dn($);
      St(O, function() {
        Ze(`Cannot construct ${$} due to unbound types`, [a]);
      }), ye([e, t, n], a ? [a] : [], function(H) {
        H = H[0];
        var G, I;
        a ? (G = H.registeredClass, I = G.instancePrototype) : I = Je.prototype;
        var Q = Ie($, function() {
          if (Object.getPrototypeOf(this) !== y)
            throw new $e("Use 'new' to construct " + $);
          if (P.constructor_body === void 0)
            throw new $e($ + " has no accessible constructor");
          var br = P.constructor_body[arguments.length];
          if (br === void 0)
            throw new $e(`Tried to invoke ctor of ${$} with invalid number of parameters (${arguments.length}) - expected (${Object.keys(P.constructor_body).toString()}) parameters instead!`);
          return br.apply(this, arguments);
        }), y = Object.create(I, {
          constructor: {
            value: Q
          }
        });
        Q.prototype = y;
        var P = new Rn($, Q, y, E, G, u, f, w);
        if (P.baseClass) {
          var q, Y;
          (Y = (q = P.baseClass).__derivedClasses) !== null && Y !== void 0 || (q.__derivedClasses = []), P.baseClass.__derivedClasses.push(P);
        }
        var _e = new Qe($, P, !0, !1, !1), tt = new Qe($ + "*", P, !1, !1, !1), wr = new Qe($ + " const*", P, !1, !0, !1);
        return Qt[e] = {
          pointerType: tt,
          constPointerType: wr
        }, Kt(O, Q), [_e, tt, wr];
      });
    }, Tt = (e, t) => {
      for (var n = [], a = 0; a < e; a++)
        n.push(R[t + a * 4 >> 2]);
      return n;
    };
    function Bn(e) {
      for (var t = 1; t < e.length; ++t)
        if (e[t] !== null && e[t].destructorFunction === void 0)
          return !0;
      return !1;
    }
    function Et(e, t, n, a, s, u) {
      var d = t.length;
      d < 2 && D("argTypes array size mismatch! Must at least get return value and 'this' types!");
      var f = t[1] !== null && n !== null, m = Bn(t), w = t[0].name !== "void", $ = d - 2, T = new Array($), E = [], O = [], H = function() {
        arguments.length !== $ && D(`function ${e} called with ${arguments.length} arguments, expected ${$}`), O.length = 0;
        var G;
        E.length = f ? 2 : 1, E[0] = s, f && (G = t[1].toWireType(O, this), E[1] = G);
        for (var I = 0; I < $; ++I)
          T[I] = t[I + 2].toWireType(O, arguments[I]), E.push(T[I]);
        var Q = a.apply(null, E);
        function y(P) {
          if (m)
            wt(O);
          else
            for (var q = f ? 1 : 2; q < t.length; q++) {
              var Y = q === 1 ? G : T[q - 2];
              t[q].destructorFunction !== null && t[q].destructorFunction(Y);
            }
          if (w)
            return t[0].fromWireType(P);
        }
        return y(Q);
      };
      return Ie(e, H);
    }
    var Vn = (e, t, n, a, s, u) => {
      var d = Tt(t, n);
      s = K(a, s), ye([], [e], function(f) {
        f = f[0];
        var m = `constructor ${f.name}`;
        if (f.registeredClass.constructor_body === void 0 && (f.registeredClass.constructor_body = []), f.registeredClass.constructor_body[t - 1] !== void 0)
          throw new $e(`Cannot register multiple constructors with identical number of parameters (${t - 1}) for class '${f.name}'! Overload resolution is currently only performed using the parameter count, not actual type info!`);
        return f.registeredClass.constructor_body[t - 1] = () => {
          Ze(`Cannot construct ${f.name} due to unbound types`, d);
        }, ye([], d, (w) => (w.splice(1, 0, null), f.registeredClass.constructor_body[t - 1] = Et(m, w, null, s, u), [])), [];
      });
    }, nr = (e) => {
      e = e.trim();
      const t = e.indexOf("(");
      return t !== -1 ? e.substr(0, t) : e;
    }, zn = (e, t, n, a, s, u, d, f, m) => {
      var w = Tt(n, a);
      t = J(t), t = nr(t), u = K(s, u), ye([], [e], function($) {
        $ = $[0];
        var T = `${$.name}.${t}`;
        t.startsWith("@@") && (t = Symbol[t.substring(2)]), f && $.registeredClass.pureVirtualFunctions.push(t);
        function E() {
          Ze(`Cannot call ${T} due to unbound types`, w);
        }
        var O = $.registeredClass.instancePrototype, H = O[t];
        return H === void 0 || H.overloadTable === void 0 && H.className !== $.name && H.argCount === n - 2 ? (E.argCount = n - 2, E.className = $.name, O[t] = E) : (Xt(O, t, T), O[t].overloadTable[n - 2] = E), ye([], w, function(G) {
          var I = Et(T, G, $, u, d);
          return O[t].overloadTable === void 0 ? (I.argCount = n - 2, O[t] = I) : O[t].overloadTable[n - 2] = I, [];
        }), [];
      });
    };
    function Gn() {
      Object.assign(ar.prototype, {
        get(e) {
          return this.allocated[e];
        },
        has(e) {
          return this.allocated[e] !== void 0;
        },
        allocate(e) {
          var t = this.freelist.pop() || this.allocated.length;
          return this.allocated[t] = e, t;
        },
        free(e) {
          this.allocated[e] = void 0, this.freelist.push(e);
        }
      });
    }
    function ar() {
      this.allocated = [void 0], this.freelist = [];
    }
    var Z = new ar(), Ot = (e) => {
      e >= Z.reserved && --Z.get(e).refcount === 0 && Z.free(e);
    }, qn = () => {
      for (var e = 0, t = Z.reserved; t < Z.allocated.length; ++t)
        Z.allocated[t] !== void 0 && ++e;
      return e;
    }, Nn = () => {
      Z.allocated.push({
        value: void 0
      }, {
        value: null
      }, {
        value: !0
      }, {
        value: !1
      }), Z.reserved = Z.allocated.length, i.count_emval_handles = qn;
    }, se = {
      toValue: (e) => (e || D("Cannot use deleted val. handle = " + e), Z.get(e).value),
      toHandle: (e) => {
        switch (e) {
          case void 0:
            return 1;
          case null:
            return 2;
          case !0:
            return 3;
          case !1:
            return 4;
          default:
            return Z.allocate({
              refcount: 1,
              value: e
            });
        }
      }
    }, Yn = (e, t) => {
      t = J(t), te(e, {
        name: t,
        fromWireType: (n) => {
          var a = se.toValue(n);
          return Ot(n), a;
        },
        toWireType: (n, a) => se.toHandle(a),
        argPackAdvance: re,
        readValueFromPointer: bt,
        destructorFunction: null
      });
    }, Jn = (e, t, n) => {
      switch (t) {
        case 1:
          return n ? function(a) {
            return this.fromWireType(M[a >> 0]);
          } : function(a) {
            return this.fromWireType(x[a >> 0]);
          };
        case 2:
          return n ? function(a) {
            return this.fromWireType(k[a >> 1]);
          } : function(a) {
            return this.fromWireType(U[a >> 1]);
          };
        case 4:
          return n ? function(a) {
            return this.fromWireType(A[a >> 2]);
          } : function(a) {
            return this.fromWireType(R[a >> 2]);
          };
        default:
          throw new TypeError(`invalid integer width (${t}): ${e}`);
      }
    }, Qn = (e, t, n, a) => {
      t = J(t);
      function s() {
      }
      s.values = {}, te(e, {
        name: t,
        constructor: s,
        fromWireType: function(u) {
          return this.constructor.values[u];
        },
        toWireType: (u, d) => d.value,
        argPackAdvance: re,
        readValueFromPointer: Jn(t, n, a),
        destructorFunction: null
      }), St(t, s);
    }, Mt = (e, t) => {
      var n = ve[e];
      return n === void 0 && D(t + " has unknown type " + rr(e)), n;
    }, Xn = (e, t, n) => {
      var a = Mt(e, "enum");
      t = J(t);
      var s = a.constructor, u = Object.create(a.constructor.prototype, {
        value: {
          value: n
        },
        constructor: {
          value: Ie(`${a.name}_${t}`, function() {
          })
        }
      });
      s.values[n] = u, s[t] = u;
    }, At = (e) => {
      if (e === null)
        return "null";
      var t = typeof e;
      return t === "object" || t === "array" || t === "function" ? e.toString() : "" + e;
    }, Zn = (e, t) => {
      switch (t) {
        case 4:
          return function(n) {
            return this.fromWireType(ae[n >> 2]);
          };
        case 8:
          return function(n) {
            return this.fromWireType(ge[n >> 3]);
          };
        default:
          throw new TypeError(`invalid float width (${t}): ${e}`);
      }
    }, Kn = (e, t, n) => {
      t = J(t), te(e, {
        name: t,
        fromWireType: (a) => a,
        toWireType: (a, s) => s,
        argPackAdvance: re,
        readValueFromPointer: Zn(t, n),
        destructorFunction: null
      });
    }, ea = (e, t, n, a, s, u, d) => {
      var f = Tt(t, n);
      e = J(e), e = nr(e), s = K(a, s), St(e, function() {
        Ze(`Cannot call ${e} due to unbound types`, f);
      }, t - 1), ye([], f, function(m) {
        var w = [m[0], null].concat(m.slice(1));
        return Kt(e, Et(e, w, null, s, u), t - 1), [];
      });
    }, ta = (e, t, n) => {
      switch (t) {
        case 1:
          return n ? (a) => M[a >> 0] : (a) => x[a >> 0];
        case 2:
          return n ? (a) => k[a >> 1] : (a) => U[a >> 1];
        case 4:
          return n ? (a) => A[a >> 2] : (a) => R[a >> 2];
        default:
          throw new TypeError(`invalid integer width (${t}): ${e}`);
      }
    }, ra = (e, t, n, a, s) => {
      t = J(t);
      var u = ($) => $;
      if (a === 0) {
        var d = 32 - 8 * n;
        u = ($) => $ << d >>> d;
      }
      var f = t.includes("unsigned"), m = ($, T) => {
      }, w;
      f ? w = function($, T) {
        return m(T, this.name), T >>> 0;
      } : w = function($, T) {
        return m(T, this.name), T;
      }, te(e, {
        name: t,
        fromWireType: u,
        toWireType: w,
        argPackAdvance: re,
        readValueFromPointer: ta(t, n, a !== 0),
        destructorFunction: null
      });
    }, na = (e, t, n) => {
      var a = [Int8Array, Uint8Array, Int16Array, Uint16Array, Int32Array, Uint32Array, Float32Array, Float64Array], s = a[t];
      function u(d) {
        var f = R[d >> 2], m = R[d + 4 >> 2];
        return new s(M.buffer, m, f);
      }
      n = J(n), te(e, {
        name: n,
        fromWireType: u,
        argPackAdvance: re,
        readValueFromPointer: u
      }, {
        ignoreDuplicateRegistrations: !0
      });
    }, or = (e, t, n, a) => {
      if (!(a > 0))
        return 0;
      for (var s = n, u = n + a - 1, d = 0; d < e.length; ++d) {
        var f = e.charCodeAt(d);
        if (f >= 55296 && f <= 57343) {
          var m = e.charCodeAt(++d);
          f = 65536 + ((f & 1023) << 10) | m & 1023;
        }
        if (f <= 127) {
          if (n >= u)
            break;
          t[n++] = f;
        } else if (f <= 2047) {
          if (n + 1 >= u)
            break;
          t[n++] = 192 | f >> 6, t[n++] = 128 | f & 63;
        } else if (f <= 65535) {
          if (n + 2 >= u)
            break;
          t[n++] = 224 | f >> 12, t[n++] = 128 | f >> 6 & 63, t[n++] = 128 | f & 63;
        } else {
          if (n + 3 >= u)
            break;
          t[n++] = 240 | f >> 18, t[n++] = 128 | f >> 12 & 63, t[n++] = 128 | f >> 6 & 63, t[n++] = 128 | f & 63;
        }
      }
      return t[n] = 0, n - s;
    }, aa = (e, t, n) => or(e, x, t, n), ir = (e) => {
      for (var t = 0, n = 0; n < e.length; ++n) {
        var a = e.charCodeAt(n);
        a <= 127 ? t++ : a <= 2047 ? t += 2 : a >= 55296 && a <= 57343 ? (t += 4, ++n) : t += 3;
      }
      return t;
    }, sr = typeof TextDecoder < "u" ? new TextDecoder("utf8") : void 0, oa = (e, t, n) => {
      for (var a = t + n, s = t; e[s] && !(s >= a); )
        ++s;
      if (s - t > 16 && e.buffer && sr)
        return sr.decode(e.subarray(t, s));
      for (var u = ""; t < s; ) {
        var d = e[t++];
        if (!(d & 128)) {
          u += String.fromCharCode(d);
          continue;
        }
        var f = e[t++] & 63;
        if ((d & 224) == 192) {
          u += String.fromCharCode((d & 31) << 6 | f);
          continue;
        }
        var m = e[t++] & 63;
        if ((d & 240) == 224 ? d = (d & 15) << 12 | f << 6 | m : d = (d & 7) << 18 | f << 12 | m << 6 | e[t++] & 63, d < 65536)
          u += String.fromCharCode(d);
        else {
          var w = d - 65536;
          u += String.fromCharCode(55296 | w >> 10, 56320 | w & 1023);
        }
      }
      return u;
    }, Dt = (e, t) => e ? oa(x, e, t) : "", ia = (e, t) => {
      t = J(t);
      var n = t === "std::string";
      te(e, {
        name: t,
        fromWireType(a) {
          var s = R[a >> 2], u = a + 4, d;
          if (n)
            for (var f = u, m = 0; m <= s; ++m) {
              var w = u + m;
              if (m == s || x[w] == 0) {
                var $ = w - f, T = Dt(f, $);
                d === void 0 ? d = T : (d += "\0", d += T), f = w + 1;
              }
            }
          else {
            for (var E = new Array(s), m = 0; m < s; ++m)
              E[m] = String.fromCharCode(x[u + m]);
            d = E.join("");
          }
          return ce(a), d;
        },
        toWireType(a, s) {
          s instanceof ArrayBuffer && (s = new Uint8Array(s));
          var u, d = typeof s == "string";
          d || s instanceof Uint8Array || s instanceof Uint8ClampedArray || s instanceof Int8Array || D("Cannot pass non-string to std::string"), n && d ? u = ir(s) : u = s.length;
          var f = kt(4 + u + 1), m = f + 4;
          if (R[f >> 2] = u, n && d)
            aa(s, m, u + 1);
          else if (d)
            for (var w = 0; w < u; ++w) {
              var $ = s.charCodeAt(w);
              $ > 255 && (ce(m), D("String has UTF-16 code units that do not fit in 8 bits")), x[m + w] = $;
            }
          else
            for (var w = 0; w < u; ++w)
              x[m + w] = s[w];
          return a !== null && a.push(ce, f), f;
        },
        argPackAdvance: re,
        readValueFromPointer: Zt,
        destructorFunction(a) {
          ce(a);
        }
      });
    }, cr = typeof TextDecoder < "u" ? new TextDecoder("utf-16le") : void 0, sa = (e, t) => {
      for (var n = e, a = n >> 1, s = a + t / 2; !(a >= s) && U[a]; )
        ++a;
      if (n = a << 1, n - e > 32 && cr)
        return cr.decode(x.subarray(e, n));
      for (var u = "", d = 0; !(d >= t / 2); ++d) {
        var f = k[e + d * 2 >> 1];
        if (f == 0)
          break;
        u += String.fromCharCode(f);
      }
      return u;
    }, ca = (e, t, n) => {
      var a;
      if ((a = n) !== null && a !== void 0 || (n = 2147483647), n < 2)
        return 0;
      n -= 2;
      for (var s = t, u = n < e.length * 2 ? n / 2 : e.length, d = 0; d < u; ++d) {
        var f = e.charCodeAt(d);
        k[t >> 1] = f, t += 2;
      }
      return k[t >> 1] = 0, t - s;
    }, ua = (e) => e.length * 2, la = (e, t) => {
      for (var n = 0, a = ""; !(n >= t / 4); ) {
        var s = A[e + n * 4 >> 2];
        if (s == 0)
          break;
        if (++n, s >= 65536) {
          var u = s - 65536;
          a += String.fromCharCode(55296 | u >> 10, 56320 | u & 1023);
        } else
          a += String.fromCharCode(s);
      }
      return a;
    }, da = (e, t, n) => {
      var a;
      if ((a = n) !== null && a !== void 0 || (n = 2147483647), n < 4)
        return 0;
      for (var s = t, u = s + n - 4, d = 0; d < e.length; ++d) {
        var f = e.charCodeAt(d);
        if (f >= 55296 && f <= 57343) {
          var m = e.charCodeAt(++d);
          f = 65536 + ((f & 1023) << 10) | m & 1023;
        }
        if (A[t >> 2] = f, t += 4, t + 4 > u)
          break;
      }
      return A[t >> 2] = 0, t - s;
    }, fa = (e) => {
      for (var t = 0, n = 0; n < e.length; ++n) {
        var a = e.charCodeAt(n);
        a >= 55296 && a <= 57343 && ++n, t += 4;
      }
      return t;
    }, ha = (e, t, n) => {
      n = J(n);
      var a, s, u, d, f;
      t === 2 ? (a = sa, s = ca, d = ua, u = () => U, f = 1) : t === 4 && (a = la, s = da, d = fa, u = () => R, f = 2), te(e, {
        name: n,
        fromWireType: (m) => {
          for (var w = R[m >> 2], $ = u(), T, E = m + 4, O = 0; O <= w; ++O) {
            var H = m + 4 + O * t;
            if (O == w || $[H >> f] == 0) {
              var G = H - E, I = a(E, G);
              T === void 0 ? T = I : (T += "\0", T += I), E = H + t;
            }
          }
          return ce(m), T;
        },
        toWireType: (m, w) => {
          typeof w != "string" && D(`Cannot pass non-string to C++ string type ${n}`);
          var $ = d(w), T = kt(4 + $ + t);
          return R[T >> 2] = $ >> f, s(w, T + 4, $ + t), m !== null && m.push(ce, T), T;
        },
        argPackAdvance: re,
        readValueFromPointer: bt,
        destructorFunction(m) {
          ce(m);
        }
      });
    }, pa = (e, t, n, a, s, u) => {
      Ge[e] = {
        name: J(t),
        rawConstructor: K(n, a),
        rawDestructor: K(s, u),
        fields: []
      };
    }, ma = (e, t, n, a, s, u, d, f, m, w) => {
      Ge[e].fields.push({
        fieldName: J(t),
        getterReturnType: n,
        getter: K(a, s),
        getterContext: u,
        setterArgumentType: d,
        setter: K(f, m),
        setterContext: w
      });
    }, va = (e, t) => {
      t = J(t), te(e, {
        isVoid: !0,
        name: t,
        argPackAdvance: 0,
        fromWireType: () => {
        },
        toWireType: (n, a) => {
        }
      });
    }, Rt = [], ya = (e, t, n, a) => (e = Rt[e], t = se.toValue(t), e(null, t, n, a)), ga = {}, wa = (e) => {
      var t = ga[e];
      return t === void 0 ? J(e) : t;
    }, ur = () => {
      if (typeof globalThis == "object")
        return globalThis;
      function e(t) {
        t.$$$embind_global$$$ = t;
        var n = typeof $$$embind_global$$$ == "object" && t.$$$embind_global$$$ == t;
        return n || delete t.$$$embind_global$$$, n;
      }
      if (typeof $$$embind_global$$$ == "object" || (typeof global == "object" && e(global) ? $$$embind_global$$$ = global : typeof self == "object" && e(self) && ($$$embind_global$$$ = self), typeof $$$embind_global$$$ == "object"))
        return $$$embind_global$$$;
      throw Error("unable to get global object.");
    }, ba = (e) => e === 0 ? se.toHandle(ur()) : (e = wa(e), se.toHandle(ur()[e])), Ca = (e) => {
      var t = Rt.length;
      return Rt.push(e), t;
    }, $a = (e, t) => {
      for (var n = new Array(e), a = 0; a < e; ++a)
        n[a] = Mt(R[t + a * 4 >> 2], "parameter " + a);
      return n;
    }, _a = Reflect.construct, Sa = (e, t, n) => {
      var a = [], s = e.toWireType(a, n);
      return a.length && (R[t >> 2] = se.toHandle(a)), s;
    }, Pa = (e, t, n) => {
      var a = $a(e, t), s = a.shift();
      e--;
      var u = new Array(e), d = (m, w, $, T) => {
        for (var E = 0, O = 0; O < e; ++O)
          u[O] = a[O].readValueFromPointer(T + E), E += a[O].argPackAdvance;
        for (var H = n === 1 ? _a(w, u) : w.apply(m, u), O = 0; O < e; ++O) {
          var G, I;
          (G = (I = a[O]).deleteObject) === null || G === void 0 || G.call(I, u[O]);
        }
        return Sa(s, $, H);
      }, f = `methodCaller<(${a.map((m) => m.name).join(", ")}) => ${s.name}>`;
      return Ca(Ie(f, d));
    }, Ta = (e) => {
      e > 4 && (Z.get(e).refcount += 1);
    }, Ea = (e) => {
      var t = se.toValue(e);
      wt(t), Ot(e);
    }, Oa = (e, t) => {
      e = Mt(e, "_emval_take_value");
      var n = e.readValueFromPointer(t);
      return se.toHandle(n);
    }, Ma = () => {
      be("");
    }, Aa = (e, t, n) => x.copyWithin(e, t, t + n), Da = () => 2147483648, Ra = (e) => {
      var t = F.buffer, n = (e - t.byteLength + 65535) / 65536;
      try {
        return F.grow(n), we(), 1;
      } catch (a) {
      }
    }, xa = (e) => {
      var t = x.length;
      e >>>= 0;
      var n = Da();
      if (e > n)
        return !1;
      for (var a = (m, w) => m + (w - m % w) % w, s = 1; s <= 4; s *= 2) {
        var u = t * (1 + 0.2 / s);
        u = Math.min(u, e + 100663296);
        var d = Math.min(n, a(Math.max(e, u), 65536)), f = Ra(d);
        if (f)
          return !0;
      }
      return !1;
    }, xt = {}, ka = () => v || "./this.program", Fe = () => {
      if (!Fe.strings) {
        var e = (typeof navigator == "object" && navigator.languages && navigator.languages[0] || "C").replace("-", "_") + ".UTF-8", t = {
          USER: "web_user",
          LOGNAME: "web_user",
          PATH: "/",
          PWD: "/",
          HOME: "/home/web_user",
          LANG: e,
          _: ka()
        };
        for (var n in xt)
          xt[n] === void 0 ? delete t[n] : t[n] = xt[n];
        var a = [];
        for (var n in t)
          a.push(`${n}=${t[n]}`);
        Fe.strings = a;
      }
      return Fe.strings;
    }, Ia = (e, t) => {
      for (var n = 0; n < e.length; ++n)
        M[t++ >> 0] = e.charCodeAt(n);
      M[t >> 0] = 0;
    }, Fa = (e, t) => {
      var n = 0;
      return Fe().forEach((a, s) => {
        var u = t + n;
        R[e + s * 4 >> 2] = u, Ia(a, u), n += a.length + 1;
      }), 0;
    }, Ua = (e, t) => {
      var n = Fe();
      R[e >> 2] = n.length;
      var a = 0;
      return n.forEach((s) => a += s.length + 1), R[t >> 2] = a, 0;
    }, Wa = (e) => e, Ke = (e) => e % 4 === 0 && (e % 100 !== 0 || e % 400 === 0), ja = (e, t) => {
      for (var n = 0, a = 0; a <= t; n += e[a++])
        ;
      return n;
    }, lr = [31, 29, 31, 30, 31, 30, 31, 31, 30, 31, 30, 31], dr = [31, 28, 31, 30, 31, 30, 31, 31, 30, 31, 30, 31], La = (e, t) => {
      for (var n = new Date(e.getTime()); t > 0; ) {
        var a = Ke(n.getFullYear()), s = n.getMonth(), u = (a ? lr : dr)[s];
        if (t > u - n.getDate())
          t -= u - n.getDate() + 1, n.setDate(1), s < 11 ? n.setMonth(s + 1) : (n.setMonth(0), n.setFullYear(n.getFullYear() + 1));
        else
          return n.setDate(n.getDate() + t), n;
      }
      return n;
    };
    function Ha(e, t, n) {
      var a = n > 0 ? n : ir(e) + 1, s = new Array(a), u = or(e, s, 0, s.length);
      return t && (s.length = u), s;
    }
    var Ba = (e, t) => {
      M.set(e, t);
    }, Va = (e, t, n, a) => {
      var s = R[a + 40 >> 2], u = {
        tm_sec: A[a >> 2],
        tm_min: A[a + 4 >> 2],
        tm_hour: A[a + 8 >> 2],
        tm_mday: A[a + 12 >> 2],
        tm_mon: A[a + 16 >> 2],
        tm_year: A[a + 20 >> 2],
        tm_wday: A[a + 24 >> 2],
        tm_yday: A[a + 28 >> 2],
        tm_isdst: A[a + 32 >> 2],
        tm_gmtoff: A[a + 36 >> 2],
        tm_zone: s ? Dt(s) : ""
      }, d = Dt(n), f = {
        "%c": "%a %b %d %H:%M:%S %Y",
        "%D": "%m/%d/%y",
        "%F": "%Y-%m-%d",
        "%h": "%b",
        "%r": "%I:%M:%S %p",
        "%R": "%H:%M",
        "%T": "%H:%M:%S",
        "%x": "%m/%d/%y",
        "%X": "%H:%M:%S",
        "%Ec": "%c",
        "%EC": "%C",
        "%Ex": "%m/%d/%y",
        "%EX": "%H:%M:%S",
        "%Ey": "%y",
        "%EY": "%Y",
        "%Od": "%d",
        "%Oe": "%e",
        "%OH": "%H",
        "%OI": "%I",
        "%Om": "%m",
        "%OM": "%M",
        "%OS": "%S",
        "%Ou": "%u",
        "%OU": "%U",
        "%OV": "%V",
        "%Ow": "%w",
        "%OW": "%W",
        "%Oy": "%y"
      };
      for (var m in f)
        d = d.replace(new RegExp(m, "g"), f[m]);
      var w = ["Sunday", "Monday", "Tuesday", "Wednesday", "Thursday", "Friday", "Saturday"], $ = ["January", "February", "March", "April", "May", "June", "July", "August", "September", "October", "November", "December"];
      function T(y, P, q) {
        for (var Y = typeof y == "number" ? y.toString() : y || ""; Y.length < P; )
          Y = q[0] + Y;
        return Y;
      }
      function E(y, P) {
        return T(y, P, "0");
      }
      function O(y, P) {
        function q(_e) {
          return _e < 0 ? -1 : _e > 0 ? 1 : 0;
        }
        var Y;
        return (Y = q(y.getFullYear() - P.getFullYear())) === 0 && (Y = q(y.getMonth() - P.getMonth())) === 0 && (Y = q(y.getDate() - P.getDate())), Y;
      }
      function H(y) {
        switch (y.getDay()) {
          case 0:
            return new Date(y.getFullYear() - 1, 11, 29);
          case 1:
            return y;
          case 2:
            return new Date(y.getFullYear(), 0, 3);
          case 3:
            return new Date(y.getFullYear(), 0, 2);
          case 4:
            return new Date(y.getFullYear(), 0, 1);
          case 5:
            return new Date(y.getFullYear() - 1, 11, 31);
          case 6:
            return new Date(y.getFullYear() - 1, 11, 30);
        }
      }
      function G(y) {
        var P = La(new Date(y.tm_year + 1900, 0, 1), y.tm_yday), q = new Date(P.getFullYear(), 0, 4), Y = new Date(P.getFullYear() + 1, 0, 4), _e = H(q), tt = H(Y);
        return O(_e, P) <= 0 ? O(tt, P) <= 0 ? P.getFullYear() + 1 : P.getFullYear() : P.getFullYear() - 1;
      }
      var I = {
        "%a": (y) => w[y.tm_wday].substring(0, 3),
        "%A": (y) => w[y.tm_wday],
        "%b": (y) => $[y.tm_mon].substring(0, 3),
        "%B": (y) => $[y.tm_mon],
        "%C": (y) => {
          var P = y.tm_year + 1900;
          return E(P / 100 | 0, 2);
        },
        "%d": (y) => E(y.tm_mday, 2),
        "%e": (y) => T(y.tm_mday, 2, " "),
        "%g": (y) => G(y).toString().substring(2),
        "%G": (y) => G(y),
        "%H": (y) => E(y.tm_hour, 2),
        "%I": (y) => {
          var P = y.tm_hour;
          return P == 0 ? P = 12 : P > 12 && (P -= 12), E(P, 2);
        },
        "%j": (y) => E(y.tm_mday + ja(Ke(y.tm_year + 1900) ? lr : dr, y.tm_mon - 1), 3),
        "%m": (y) => E(y.tm_mon + 1, 2),
        "%M": (y) => E(y.tm_min, 2),
        "%n": () => `
`,
        "%p": (y) => y.tm_hour >= 0 && y.tm_hour < 12 ? "AM" : "PM",
        "%S": (y) => E(y.tm_sec, 2),
        "%t": () => "	",
        "%u": (y) => y.tm_wday || 7,
        "%U": (y) => {
          var P = y.tm_yday + 7 - y.tm_wday;
          return E(Math.floor(P / 7), 2);
        },
        "%V": (y) => {
          var P = Math.floor((y.tm_yday + 7 - (y.tm_wday + 6) % 7) / 7);
          if ((y.tm_wday + 371 - y.tm_yday - 2) % 7 <= 2 && P++, P) {
            if (P == 53) {
              var q = (y.tm_wday + 371 - y.tm_yday) % 7;
              q != 4 && (q != 3 || !Ke(y.tm_year)) && (P = 1);
            }
          } else {
            P = 52;
            var Y = (y.tm_wday + 7 - y.tm_yday - 1) % 7;
            (Y == 4 || Y == 5 && Ke(y.tm_year % 400 - 1)) && P++;
          }
          return E(P, 2);
        },
        "%w": (y) => y.tm_wday,
        "%W": (y) => {
          var P = y.tm_yday + 7 - (y.tm_wday + 6) % 7;
          return E(Math.floor(P / 7), 2);
        },
        "%y": (y) => (y.tm_year + 1900).toString().substring(2),
        "%Y": (y) => y.tm_year + 1900,
        "%z": (y) => {
          var P = y.tm_gmtoff, q = P >= 0;
          return P = Math.abs(P) / 60, P = P / 60 * 100 + P % 60, (q ? "+" : "-") + ("0000" + P).slice(-4);
        },
        "%Z": (y) => y.tm_zone,
        "%%": () => "%"
      };
      d = d.replace(/%%/g, "\0\0");
      for (var m in I)
        d.includes(m) && (d = d.replace(new RegExp(m, "g"), I[m](u)));
      d = d.replace(/\0\0/g, "%");
      var Q = Ha(d, !1);
      return Q.length > t ? 0 : (Ba(Q, e), Q.length - 1);
    }, za = (e, t, n, a, s) => Va(e, t, n, a);
    Gt = i.InternalError = class extends Error {
      constructor(e) {
        super(e), this.name = "InternalError";
      }
    }, vn(), $e = i.BindingError = class extends Error {
      constructor(e) {
        super(e), this.name = "BindingError";
      }
    }, On(), Sn(), Fn(), tr = i.UnboundTypeError = Ln(Error, "UnboundTypeError"), Gn(), Nn();
    var Ga = {
      s: an,
      u: on,
      b: cn,
      g: un,
      q: ln,
      J: dn,
      f: fn,
      V: hn,
      d: sn,
      da: pn,
      Q: mn,
      _: gn,
      ca: Hn,
      ba: Vn,
      w: zn,
      Y: Yn,
      x: Qn,
      h: Xn,
      L: Kn,
      M: ea,
      t: ra,
      o: na,
      K: ia,
      C: ha,
      A: pa,
      ea: ma,
      $: va,
      R: ya,
      ha: Ot,
      fa: ba,
      Z: Pa,
      N: Ta,
      O: Ea,
      aa: Oa,
      B: Ma,
      X: Aa,
      W: xa,
      T: Fa,
      U: Ua,
      E: so,
      D: Qa,
      F: io,
      n: co,
      a: qa,
      e: Za,
      m: Ja,
      k: eo,
      H: ao,
      v: ro,
      G: oo,
      z: lo,
      P: ho,
      l: Ka,
      j: Xa,
      c: Ya,
      p: Na,
      I: no,
      r: uo,
      i: to,
      y: fo,
      ga: Wa,
      S: za
    }, N = nn(), ce = i._free = (e) => (ce = i._free = N.ka)(e), kt = i._malloc = (e) => (kt = i._malloc = N.la)(e), fr = (e) => (fr = N.na)(e), L = (e, t) => (L = N.oa)(e, t), Ue = (e) => (Ue = N.pa)(e), V = () => (V = N.qa)(), z = (e) => (z = N.ra)(e), hr = (e) => (hr = N.sa)(e), pr = (e) => (pr = N.ta)(e), mr = (e, t, n) => (mr = N.ua)(e, t, n), vr = (e) => (vr = N.va)(e);
    i.dynCall_viijii = (e, t, n, a, s, u, d) => (i.dynCall_viijii = N.wa)(e, t, n, a, s, u, d);
    var yr = i.dynCall_jiiii = (e, t, n, a, s) => (yr = i.dynCall_jiiii = N.xa)(e, t, n, a, s);
    i.dynCall_iiiiij = (e, t, n, a, s, u, d) => (i.dynCall_iiiiij = N.ya)(e, t, n, a, s, u, d), i.dynCall_iiiiijj = (e, t, n, a, s, u, d, f, m) => (i.dynCall_iiiiijj = N.za)(e, t, n, a, s, u, d, f, m), i.dynCall_iiiiiijj = (e, t, n, a, s, u, d, f, m, w) => (i.dynCall_iiiiiijj = N.Aa)(e, t, n, a, s, u, d, f, m, w);
    function qa(e, t) {
      var n = V();
      try {
        return B(e)(t);
      } catch (a) {
        if (z(n), a !== a + 0)
          throw a;
        L(1, 0);
      }
    }
    function Na(e, t, n, a) {
      var s = V();
      try {
        B(e)(t, n, a);
      } catch (u) {
        if (z(s), u !== u + 0)
          throw u;
        L(1, 0);
      }
    }
    function Ya(e, t, n) {
      var a = V();
      try {
        B(e)(t, n);
      } catch (s) {
        if (z(a), s !== s + 0)
          throw s;
        L(1, 0);
      }
    }
    function Ja(e, t, n, a) {
      var s = V();
      try {
        return B(e)(t, n, a);
      } catch (u) {
        if (z(s), u !== u + 0)
          throw u;
        L(1, 0);
      }
    }
    function Qa(e, t, n, a, s) {
      var u = V();
      try {
        return B(e)(t, n, a, s);
      } catch (d) {
        if (z(u), d !== d + 0)
          throw d;
        L(1, 0);
      }
    }
    function Xa(e, t) {
      var n = V();
      try {
        B(e)(t);
      } catch (a) {
        if (z(n), a !== a + 0)
          throw a;
        L(1, 0);
      }
    }
    function Za(e, t, n) {
      var a = V();
      try {
        return B(e)(t, n);
      } catch (s) {
        if (z(a), s !== s + 0)
          throw s;
        L(1, 0);
      }
    }
    function Ka(e) {
      var t = V();
      try {
        B(e)();
      } catch (n) {
        if (z(t), n !== n + 0)
          throw n;
        L(1, 0);
      }
    }
    function eo(e, t, n, a, s) {
      var u = V();
      try {
        return B(e)(t, n, a, s);
      } catch (d) {
        if (z(u), d !== d + 0)
          throw d;
        L(1, 0);
      }
    }
    function to(e, t, n, a, s, u, d, f, m, w, $) {
      var T = V();
      try {
        B(e)(t, n, a, s, u, d, f, m, w, $);
      } catch (E) {
        if (z(T), E !== E + 0)
          throw E;
        L(1, 0);
      }
    }
    function ro(e, t, n, a, s, u, d) {
      var f = V();
      try {
        return B(e)(t, n, a, s, u, d);
      } catch (m) {
        if (z(f), m !== m + 0)
          throw m;
        L(1, 0);
      }
    }
    function no(e, t, n, a, s) {
      var u = V();
      try {
        B(e)(t, n, a, s);
      } catch (d) {
        if (z(u), d !== d + 0)
          throw d;
        L(1, 0);
      }
    }
    function ao(e, t, n, a, s, u) {
      var d = V();
      try {
        return B(e)(t, n, a, s, u);
      } catch (f) {
        if (z(d), f !== f + 0)
          throw f;
        L(1, 0);
      }
    }
    function oo(e, t, n, a, s, u, d, f) {
      var m = V();
      try {
        return B(e)(t, n, a, s, u, d, f);
      } catch (w) {
        if (z(m), w !== w + 0)
          throw w;
        L(1, 0);
      }
    }
    function io(e, t, n, a) {
      var s = V();
      try {
        return B(e)(t, n, a);
      } catch (u) {
        if (z(s), u !== u + 0)
          throw u;
        L(1, 0);
      }
    }
    function so(e, t, n, a) {
      var s = V();
      try {
        return B(e)(t, n, a);
      } catch (u) {
        if (z(s), u !== u + 0)
          throw u;
        L(1, 0);
      }
    }
    function co(e) {
      var t = V();
      try {
        return B(e)();
      } catch (n) {
        if (z(t), n !== n + 0)
          throw n;
        L(1, 0);
      }
    }
    function uo(e, t, n, a, s, u, d, f) {
      var m = V();
      try {
        B(e)(t, n, a, s, u, d, f);
      } catch (w) {
        if (z(m), w !== w + 0)
          throw w;
        L(1, 0);
      }
    }
    function lo(e, t, n, a, s, u, d, f, m, w, $, T) {
      var E = V();
      try {
        return B(e)(t, n, a, s, u, d, f, m, w, $, T);
      } catch (O) {
        if (z(E), O !== O + 0)
          throw O;
        L(1, 0);
      }
    }
    function fo(e, t, n, a, s, u, d, f, m, w, $, T, E, O, H, G) {
      var I = V();
      try {
        B(e)(t, n, a, s, u, d, f, m, w, $, T, E, O, H, G);
      } catch (Q) {
        if (z(I), Q !== Q + 0)
          throw Q;
        L(1, 0);
      }
    }
    function ho(e, t, n, a, s) {
      var u = V();
      try {
        return yr(e, t, n, a, s);
      } catch (d) {
        if (z(u), d !== d + 0)
          throw d;
        L(1, 0);
      }
    }
    var et;
    me = function e() {
      et || gr(), et || (me = e);
    };
    function gr() {
      if (oe > 0 || (lt(), oe > 0))
        return;
      function e() {
        et || (et = !0, i.calledRun = !0, !j && (dt(), c(i), i.onRuntimeInitialized && i.onRuntimeInitialized(), ft()));
      }
      i.setStatus ? (i.setStatus("Running..."), setTimeout(function() {
        setTimeout(function() {
          i.setStatus("");
        }, 1), e();
      }, 1)) : e();
    }
    if (i.preInit)
      for (typeof i.preInit == "function" && (i.preInit = [i.preInit]); i.preInit.length > 0; )
        i.preInit.pop()();
    return gr(), o.ready;
  };
})();
function No(r) {
  return Bt(
    ct,
    r
  );
}
function Li(r) {
  return zo(
    ct,
    r
  );
}
async function Yo(r, o) {
  return Go(
    ct,
    r,
    o
  );
}
async function Jo(r, o) {
  return qo(
    ct,
    r,
    o
  );
}
var je;
class ut extends EventTarget {
  constructor(o = {}) {
    var i;
    super(), bo(this, je, void 0);
    try {
      const c = (i = o == null ? void 0 : o.formats) == null ? void 0 : i.filter(
        (l) => l !== "unknown"
      );
      if ((c == null ? void 0 : c.length) === 0)
        throw new TypeError("Hint option provided, but is empty.");
      c == null || c.forEach((l) => {
        if (!ot.has(l))
          throw new TypeError(
            `Failed to read the 'formats' property from 'BarcodeDetectorOptions': The provided value '${l}' is not a valid enum value of type BarcodeFormat.`
          );
      }), Co(this, je, c != null ? c : []), No().then((l) => {
        this.dispatchEvent(
          new CustomEvent("load", {
            detail: l
          })
        );
      }).catch((l) => {
        this.dispatchEvent(new CustomEvent("error", { detail: l }));
      });
    } catch (c) {
      throw $r(
        c,
        "Failed to construct 'BarcodeDetector'"
      );
    }
  }
  static async getSupportedFormats() {
    return $o.filter((o) => o !== "unknown");
  }
  async detect(o) {
    try {
      const i = await Mo(o);
      if (i === null)
        return [];
      let c;
      try {
        jr(i) ? c = await Yo(i, {
          tryHarder: !0,
          formats: Cr(this, je).map((l) => ot.get(l))
        }) : c = await Jo(i, {
          tryHarder: !0,
          formats: Cr(this, je).map((l) => ot.get(l))
        });
      } catch (l) {
        throw console.error(l), new DOMException(
          "Barcode detection service unavailable.",
          "NotSupportedError"
        );
      }
      return c.map((l) => {
        const {
          topLeft: { x: h, y: v },
          topRight: { x: g, y: b },
          bottomLeft: { x: p, y: _ },
          bottomRight: { x: S, y: C }
        } = l.position, W = Math.min(h, g, p, S), F = Math.min(v, b, _, C), j = Math.max(h, g, p, S), M = Math.max(v, b, _, C);
        return {
          boundingBox: new DOMRectReadOnly(
            W,
            F,
            j - W,
            M - F
          ),
          rawValue: l.text,
          format: _o(l.format),
          cornerPoints: [
            {
              x: h,
              y: v
            },
            {
              x: g,
              y: b
            },
            {
              x: S,
              y: C
            },
            {
              x: p,
              y: _
            }
          ]
        };
      });
    } catch (i) {
      throw $r(
        i,
        "Failed to execute 'detect' on 'BarcodeDetector'"
      );
    }
  }
}
je = /* @__PURE__ */ new WeakMap();
const Vt = (r, o, i = "error") => {
  let c, l;
  const h = new Promise(
    (v, g) => {
      c = v, l = g, r.addEventListener(o, c), r.addEventListener(i, l);
    }
  );
  return h.finally(() => {
    r.removeEventListener(o, c), r.removeEventListener(i, l);
  }), h;
}, Pr = (r) => new Promise((o) => setTimeout(o, r));
class Qo extends Error {
  constructor() {
    super("can't process cross-origin image"), this.name = "DropImageFetchError";
  }
}
class Vr extends Error {
  constructor() {
    super("this browser has no Stream API support"), this.name = "StreamApiNotSupportedError";
  }
}
class Xo extends Error {
  constructor() {
    super(
      "camera access is only permitted in secure context. Use HTTPS or localhost rather than HTTP."
    ), this.name = "InsecureContextError";
  }
}
class Zo extends Error {
  constructor() {
    super(
      "Loading camera stream timed out after 3 seconds. If you are on iOS in PWA mode, this is a known issue (see https://github.com/gruhn/vue-qrcode-reader/issues/298)"
    ), this.name = "StreamLoadTimeoutError";
  }
}
let Wt;
const Ko = (r) => {
  Wt = new ut({ formats: r });
}, ei = async (r, {
  detectHandler: o,
  locateHandler: i,
  minDelay: c,
  formats: l
}) => {
  Wt = new ut({ formats: l });
  const h = (v) => async (g) => {
    if (r.readyState > 1) {
      const { lastScanned: b, contentBefore: p, lastScanHadContent: _ } = v;
      if (g - b < c)
        window.requestAnimationFrame(h(v));
      else {
        const S = await Wt.detect(r), C = S.some((j) => !p.includes(j.rawValue));
        C && o(S);
        const W = S.length > 0;
        W && i(S), !W && _ && i(S);
        const F = {
          lastScanned: g,
          lastScanHadContent: W,
          // It can happen that a QR code is constantly in view of the camera but
          // maybe a scanned frame is a bit blurry and we detect nothing but in the
          // next frame we detect the code again. We also want to avoid emitting
          // a `detect` event in such a case. So we don't reset `contentBefore`,
          // if we detect nothing, only if we detect something new.
          contentBefore: C ? S.map((j) => j.rawValue) : p
        };
        window.requestAnimationFrame(h(F));
      }
    }
  };
  h({
    lastScanned: performance.now(),
    contentBefore: [],
    lastScanHadContent: !1
  })(performance.now());
}, ti = async (r) => {
  if (r.startsWith("http") && r.includes(location.host) === !1)
    throw new Qo();
  const o = document.createElement("img");
  return o.src = r, await Vt(o, "load"), o;
}, zr = async (r, o = ["qr_code"]) => await new ut({
  formats: o
}).detect(r), ri = async (r, o = ["qr_code"]) => {
  const i = new ut({
    formats: o
  }), c = await ti(r);
  return await i.detect(c);
};
var Gr = {}, X = {};
Object.defineProperty(X, "__esModule", {
  value: !0
});
X.compactObject = Yr;
X.deprecated = di;
var ni = X.detectBrowser = fi;
X.disableLog = ci;
X.disableWarnings = ui;
X.extractVersion = it;
X.filterStats = hi;
X.log = li;
X.walkStats = st;
X.wrapPeerConnectionEvent = si;
function ai(r, o, i) {
  return o = oi(o), o in r ? Object.defineProperty(r, o, { value: i, enumerable: !0, configurable: !0, writable: !0 }) : r[o] = i, r;
}
function oi(r) {
  var o = ii(r, "string");
  return he(o) === "symbol" ? o : String(o);
}
function ii(r, o) {
  if (he(r) !== "object" || r === null)
    return r;
  var i = r[Symbol.toPrimitive];
  if (i !== void 0) {
    var c = i.call(r, o || "default");
    if (he(c) !== "object")
      return c;
    throw new TypeError("@@toPrimitive must return a primitive value.");
  }
  return (o === "string" ? String : Number)(r);
}
function he(r) {
  "@babel/helpers - typeof";
  return he = typeof Symbol == "function" && typeof Symbol.iterator == "symbol" ? function(o) {
    return typeof o;
  } : function(o) {
    return o && typeof Symbol == "function" && o.constructor === Symbol && o !== Symbol.prototype ? "symbol" : typeof o;
  }, he(r);
}
var qr = !0, Nr = !0;
function it(r, o, i) {
  var c = r.match(o);
  return c && c.length >= i && parseInt(c[i], 10);
}
function si(r, o, i) {
  if (r.RTCPeerConnection) {
    var c = r.RTCPeerConnection.prototype, l = c.addEventListener;
    c.addEventListener = function(v, g) {
      if (v !== o)
        return l.apply(this, arguments);
      var b = function(_) {
        var S = i(_);
        S && (g.handleEvent ? g.handleEvent(S) : g(S));
      };
      return this._eventMap = this._eventMap || {}, this._eventMap[o] || (this._eventMap[o] = /* @__PURE__ */ new Map()), this._eventMap[o].set(g, b), l.apply(this, [v, b]);
    };
    var h = c.removeEventListener;
    c.removeEventListener = function(v, g) {
      if (v !== o || !this._eventMap || !this._eventMap[o])
        return h.apply(this, arguments);
      if (!this._eventMap[o].has(g))
        return h.apply(this, arguments);
      var b = this._eventMap[o].get(g);
      return this._eventMap[o].delete(g), this._eventMap[o].size === 0 && delete this._eventMap[o], Object.keys(this._eventMap).length === 0 && delete this._eventMap, h.apply(this, [v, b]);
    }, Object.defineProperty(c, "on" + o, {
      get: function() {
        return this["_on" + o];
      },
      set: function(g) {
        this["_on" + o] && (this.removeEventListener(o, this["_on" + o]), delete this["_on" + o]), g && this.addEventListener(o, this["_on" + o] = g);
      },
      enumerable: !0,
      configurable: !0
    });
  }
}
function ci(r) {
  return typeof r != "boolean" ? new Error("Argument type: " + he(r) + ". Please use a boolean.") : (qr = r, r ? "adapter.js logging disabled" : "adapter.js logging enabled");
}
function ui(r) {
  return typeof r != "boolean" ? new Error("Argument type: " + he(r) + ". Please use a boolean.") : (Nr = !r, "adapter.js deprecation warnings " + (r ? "disabled" : "enabled"));
}
function li() {
  if ((typeof window > "u" ? "undefined" : he(window)) === "object") {
    if (qr)
      return;
    typeof console < "u" && typeof console.log == "function" && console.log.apply(console, arguments);
  }
}
function di(r, o) {
  Nr && console.warn(r + " is deprecated, please use " + o + " instead.");
}
function fi(r) {
  var o = {
    browser: null,
    version: null
  };
  if (typeof r > "u" || !r.navigator || !r.navigator.userAgent)
    return o.browser = "Not a browser.", o;
  var i = r.navigator;
  if (i.mozGetUserMedia)
    o.browser = "firefox", o.version = it(i.userAgent, /Firefox\/(\d+)\./, 1);
  else if (i.webkitGetUserMedia || r.isSecureContext === !1 && r.webkitRTCPeerConnection)
    o.browser = "chrome", o.version = it(i.userAgent, /Chrom(e|ium)\/(\d+)\./, 2);
  else if (r.RTCPeerConnection && i.userAgent.match(/AppleWebKit\/(\d+)\./))
    o.browser = "safari", o.version = it(i.userAgent, /AppleWebKit\/(\d+)\./, 1), o.supportsUnifiedPlan = r.RTCRtpTransceiver && "currentDirection" in r.RTCRtpTransceiver.prototype;
  else
    return o.browser = "Not a supported browser.", o;
  return o;
}
function Tr(r) {
  return Object.prototype.toString.call(r) === "[object Object]";
}
function Yr(r) {
  return Tr(r) ? Object.keys(r).reduce(function(o, i) {
    var c = Tr(r[i]), l = c ? Yr(r[i]) : r[i], h = c && !Object.keys(l).length;
    return l === void 0 || h ? o : Object.assign(o, ai({}, i, l));
  }, {}) : r;
}
function st(r, o, i) {
  !o || i.has(o.id) || (i.set(o.id, o), Object.keys(o).forEach(function(c) {
    c.endsWith("Id") ? st(r, r.get(o[c]), i) : c.endsWith("Ids") && o[c].forEach(function(l) {
      st(r, r.get(l), i);
    });
  }));
}
function hi(r, o, i) {
  var c = i ? "outbound-rtp" : "inbound-rtp", l = /* @__PURE__ */ new Map();
  if (o === null)
    return l;
  var h = [];
  return r.forEach(function(v) {
    v.type === "track" && v.trackIdentifier === o.id && h.push(v);
  }), h.forEach(function(v) {
    r.forEach(function(g) {
      g.type === c && g.trackId === v.id && st(r, g, l);
    });
  }), l;
}
Object.defineProperty(Gr, "__esModule", {
  value: !0
});
var pi = Gr.shimGetUserMedia = yi, mi = vi(X);
function Jr(r) {
  if (typeof WeakMap != "function")
    return null;
  var o = /* @__PURE__ */ new WeakMap(), i = /* @__PURE__ */ new WeakMap();
  return (Jr = function(l) {
    return l ? i : o;
  })(r);
}
function vi(r, o) {
  if (!o && r && r.__esModule)
    return r;
  if (r === null || fe(r) !== "object" && typeof r != "function")
    return { default: r };
  var i = Jr(o);
  if (i && i.has(r))
    return i.get(r);
  var c = {}, l = Object.defineProperty && Object.getOwnPropertyDescriptor;
  for (var h in r)
    if (h !== "default" && Object.prototype.hasOwnProperty.call(r, h)) {
      var v = l ? Object.getOwnPropertyDescriptor(r, h) : null;
      v && (v.get || v.set) ? Object.defineProperty(c, h, v) : c[h] = r[h];
    }
  return c.default = r, i && i.set(r, c), c;
}
function fe(r) {
  "@babel/helpers - typeof";
  return fe = typeof Symbol == "function" && typeof Symbol.iterator == "symbol" ? function(o) {
    return typeof o;
  } : function(o) {
    return o && typeof Symbol == "function" && o.constructor === Symbol && o !== Symbol.prototype ? "symbol" : typeof o;
  }, fe(r);
}
var Er = mi.log;
function yi(r, o) {
  var i = r && r.navigator;
  if (i.mediaDevices) {
    var c = function(p) {
      if (fe(p) !== "object" || p.mandatory || p.optional)
        return p;
      var _ = {};
      return Object.keys(p).forEach(function(S) {
        if (!(S === "require" || S === "advanced" || S === "mediaSource")) {
          var C = fe(p[S]) === "object" ? p[S] : {
            ideal: p[S]
          };
          C.exact !== void 0 && typeof C.exact == "number" && (C.min = C.max = C.exact);
          var W = function(M, x) {
            return M ? M + x.charAt(0).toUpperCase() + x.slice(1) : x === "deviceId" ? "sourceId" : x;
          };
          if (C.ideal !== void 0) {
            _.optional = _.optional || [];
            var F = {};
            typeof C.ideal == "number" ? (F[W("min", S)] = C.ideal, _.optional.push(F), F = {}, F[W("max", S)] = C.ideal, _.optional.push(F)) : (F[W("", S)] = C.ideal, _.optional.push(F));
          }
          C.exact !== void 0 && typeof C.exact != "number" ? (_.mandatory = _.mandatory || {}, _.mandatory[W("", S)] = C.exact) : ["min", "max"].forEach(function(j) {
            C[j] !== void 0 && (_.mandatory = _.mandatory || {}, _.mandatory[W(j, S)] = C[j]);
          });
        }
      }), p.advanced && (_.optional = (_.optional || []).concat(p.advanced)), _;
    }, l = function(p, _) {
      if (o.version >= 61)
        return _(p);
      if (p = JSON.parse(JSON.stringify(p)), p && fe(p.audio) === "object") {
        var S = function(M, x, k) {
          x in M && !(k in M) && (M[k] = M[x], delete M[x]);
        };
        p = JSON.parse(JSON.stringify(p)), S(p.audio, "autoGainControl", "googAutoGainControl"), S(p.audio, "noiseSuppression", "googNoiseSuppression"), p.audio = c(p.audio);
      }
      if (p && fe(p.video) === "object") {
        var C = p.video.facingMode;
        C = C && (fe(C) === "object" ? C : {
          ideal: C
        });
        var W = o.version < 66;
        if (C && (C.exact === "user" || C.exact === "environment" || C.ideal === "user" || C.ideal === "environment") && !(i.mediaDevices.getSupportedConstraints && i.mediaDevices.getSupportedConstraints().facingMode && !W)) {
          delete p.video.facingMode;
          var F;
          if (C.exact === "environment" || C.ideal === "environment" ? F = ["back", "rear"] : (C.exact === "user" || C.ideal === "user") && (F = ["front"]), F)
            return i.mediaDevices.enumerateDevices().then(function(j) {
              j = j.filter(function(x) {
                return x.kind === "videoinput";
              });
              var M = j.find(function(x) {
                return F.some(function(k) {
                  return x.label.toLowerCase().includes(k);
                });
              });
              return !M && j.length && F.includes("back") && (M = j[j.length - 1]), M && (p.video.deviceId = C.exact ? {
                exact: M.deviceId
              } : {
                ideal: M.deviceId
              }), p.video = c(p.video), Er("chrome: " + JSON.stringify(p)), _(p);
            });
        }
        p.video = c(p.video);
      }
      return Er("chrome: " + JSON.stringify(p)), _(p);
    }, h = function(p) {
      return o.version >= 64 ? p : {
        name: {
          PermissionDeniedError: "NotAllowedError",
          PermissionDismissedError: "NotAllowedError",
          InvalidStateError: "NotAllowedError",
          DevicesNotFoundError: "NotFoundError",
          ConstraintNotSatisfiedError: "OverconstrainedError",
          TrackStartError: "NotReadableError",
          MediaDeviceFailedDueToShutdown: "NotAllowedError",
          MediaDeviceKillSwitchOn: "NotAllowedError",
          TabCaptureError: "AbortError",
          ScreenCaptureError: "AbortError",
          DeviceCaptureError: "AbortError"
        }[p.name] || p.name,
        message: p.message,
        constraint: p.constraint || p.constraintName,
        toString: function() {
          return this.name + (this.message && ": ") + this.message;
        }
      };
    }, v = function(p, _, S) {
      l(p, function(C) {
        i.webkitGetUserMedia(C, _, function(W) {
          S && S(h(W));
        });
      });
    };
    if (i.getUserMedia = v.bind(i), i.mediaDevices.getUserMedia) {
      var g = i.mediaDevices.getUserMedia.bind(i.mediaDevices);
      i.mediaDevices.getUserMedia = function(b) {
        return l(b, function(p) {
          return g(p).then(function(_) {
            if (p.audio && !_.getAudioTracks().length || p.video && !_.getVideoTracks().length)
              throw _.getTracks().forEach(function(S) {
                S.stop();
              }), new DOMException("", "NotFoundError");
            return _;
          }, function(_) {
            return Promise.reject(h(_));
          });
        });
      };
    }
  }
}
var Qr = {};
Object.defineProperty(Qr, "__esModule", {
  value: !0
});
var gi = Qr.shimGetUserMedia = Ci, wi = bi(X);
function Xr(r) {
  if (typeof WeakMap != "function")
    return null;
  var o = /* @__PURE__ */ new WeakMap(), i = /* @__PURE__ */ new WeakMap();
  return (Xr = function(l) {
    return l ? i : o;
  })(r);
}
function bi(r, o) {
  if (!o && r && r.__esModule)
    return r;
  if (r === null || Se(r) !== "object" && typeof r != "function")
    return { default: r };
  var i = Xr(o);
  if (i && i.has(r))
    return i.get(r);
  var c = {}, l = Object.defineProperty && Object.getOwnPropertyDescriptor;
  for (var h in r)
    if (h !== "default" && Object.prototype.hasOwnProperty.call(r, h)) {
      var v = l ? Object.getOwnPropertyDescriptor(r, h) : null;
      v && (v.get || v.set) ? Object.defineProperty(c, h, v) : c[h] = r[h];
    }
  return c.default = r, i && i.set(r, c), c;
}
function Se(r) {
  "@babel/helpers - typeof";
  return Se = typeof Symbol == "function" && typeof Symbol.iterator == "symbol" ? function(o) {
    return typeof o;
  } : function(o) {
    return o && typeof Symbol == "function" && o.constructor === Symbol && o !== Symbol.prototype ? "symbol" : typeof o;
  }, Se(r);
}
function Ci(r, o) {
  var i = r && r.navigator, c = r && r.MediaStreamTrack;
  if (i.getUserMedia = function(b, p, _) {
    wi.deprecated("navigator.getUserMedia", "navigator.mediaDevices.getUserMedia"), i.mediaDevices.getUserMedia(b).then(p, _);
  }, !(o.version > 55 && "autoGainControl" in i.mediaDevices.getSupportedConstraints())) {
    var l = function(p, _, S) {
      _ in p && !(S in p) && (p[S] = p[_], delete p[_]);
    }, h = i.mediaDevices.getUserMedia.bind(i.mediaDevices);
    if (i.mediaDevices.getUserMedia = function(b) {
      return Se(b) === "object" && Se(b.audio) === "object" && (b = JSON.parse(JSON.stringify(b)), l(b.audio, "autoGainControl", "mozAutoGainControl"), l(b.audio, "noiseSuppression", "mozNoiseSuppression")), h(b);
    }, c && c.prototype.getSettings) {
      var v = c.prototype.getSettings;
      c.prototype.getSettings = function() {
        var b = v.apply(this, arguments);
        return l(b, "mozAutoGainControl", "autoGainControl"), l(b, "mozNoiseSuppression", "noiseSuppression"), b;
      };
    }
    if (c && c.prototype.applyConstraints) {
      var g = c.prototype.applyConstraints;
      c.prototype.applyConstraints = function(b) {
        return this.kind === "audio" && Se(b) === "object" && (b = JSON.parse(JSON.stringify(b)), l(b, "autoGainControl", "mozAutoGainControl"), l(b, "noiseSuppression", "mozNoiseSuppression")), g.apply(this, [b]);
      };
    }
  }
}
var ne = {};
Object.defineProperty(ne, "__esModule", {
  value: !0
});
ne.shimAudioContext = Di;
ne.shimCallbacksAPI = Ti;
ne.shimConstraints = en;
ne.shimCreateOfferLegacy = Ai;
var $i = ne.shimGetUserMedia = Ei;
ne.shimLocalStreamsAPI = Si;
ne.shimRTCIceServerUrls = Oi;
ne.shimRemoteStreamsAPI = Pi;
ne.shimTrackEventTransceiver = Mi;
var Zr = _i(X);
function Kr(r) {
  if (typeof WeakMap != "function")
    return null;
  var o = /* @__PURE__ */ new WeakMap(), i = /* @__PURE__ */ new WeakMap();
  return (Kr = function(l) {
    return l ? i : o;
  })(r);
}
function _i(r, o) {
  if (!o && r && r.__esModule)
    return r;
  if (r === null || pe(r) !== "object" && typeof r != "function")
    return { default: r };
  var i = Kr(o);
  if (i && i.has(r))
    return i.get(r);
  var c = {}, l = Object.defineProperty && Object.getOwnPropertyDescriptor;
  for (var h in r)
    if (h !== "default" && Object.prototype.hasOwnProperty.call(r, h)) {
      var v = l ? Object.getOwnPropertyDescriptor(r, h) : null;
      v && (v.get || v.set) ? Object.defineProperty(c, h, v) : c[h] = r[h];
    }
  return c.default = r, i && i.set(r, c), c;
}
function pe(r) {
  "@babel/helpers - typeof";
  return pe = typeof Symbol == "function" && typeof Symbol.iterator == "symbol" ? function(o) {
    return typeof o;
  } : function(o) {
    return o && typeof Symbol == "function" && o.constructor === Symbol && o !== Symbol.prototype ? "symbol" : typeof o;
  }, pe(r);
}
function Si(r) {
  if (!(pe(r) !== "object" || !r.RTCPeerConnection)) {
    if ("getLocalStreams" in r.RTCPeerConnection.prototype || (r.RTCPeerConnection.prototype.getLocalStreams = function() {
      return this._localStreams || (this._localStreams = []), this._localStreams;
    }), !("addStream" in r.RTCPeerConnection.prototype)) {
      var o = r.RTCPeerConnection.prototype.addTrack;
      r.RTCPeerConnection.prototype.addStream = function(c) {
        var l = this;
        this._localStreams || (this._localStreams = []), this._localStreams.includes(c) || this._localStreams.push(c), c.getAudioTracks().forEach(function(h) {
          return o.call(l, h, c);
        }), c.getVideoTracks().forEach(function(h) {
          return o.call(l, h, c);
        });
      }, r.RTCPeerConnection.prototype.addTrack = function(c) {
        for (var l = this, h = arguments.length, v = new Array(h > 1 ? h - 1 : 0), g = 1; g < h; g++)
          v[g - 1] = arguments[g];
        return v && v.forEach(function(b) {
          l._localStreams ? l._localStreams.includes(b) || l._localStreams.push(b) : l._localStreams = [b];
        }), o.apply(this, arguments);
      };
    }
    "removeStream" in r.RTCPeerConnection.prototype || (r.RTCPeerConnection.prototype.removeStream = function(c) {
      var l = this;
      this._localStreams || (this._localStreams = []);
      var h = this._localStreams.indexOf(c);
      if (h !== -1) {
        this._localStreams.splice(h, 1);
        var v = c.getTracks();
        this.getSenders().forEach(function(g) {
          v.includes(g.track) && l.removeTrack(g);
        });
      }
    });
  }
}
function Pi(r) {
  if (!(pe(r) !== "object" || !r.RTCPeerConnection) && ("getRemoteStreams" in r.RTCPeerConnection.prototype || (r.RTCPeerConnection.prototype.getRemoteStreams = function() {
    return this._remoteStreams ? this._remoteStreams : [];
  }), !("onaddstream" in r.RTCPeerConnection.prototype))) {
    Object.defineProperty(r.RTCPeerConnection.prototype, "onaddstream", {
      get: function() {
        return this._onaddstream;
      },
      set: function(c) {
        var l = this;
        this._onaddstream && (this.removeEventListener("addstream", this._onaddstream), this.removeEventListener("track", this._onaddstreampoly)), this.addEventListener("addstream", this._onaddstream = c), this.addEventListener("track", this._onaddstreampoly = function(h) {
          h.streams.forEach(function(v) {
            if (l._remoteStreams || (l._remoteStreams = []), !l._remoteStreams.includes(v)) {
              l._remoteStreams.push(v);
              var g = new Event("addstream");
              g.stream = v, l.dispatchEvent(g);
            }
          });
        });
      }
    });
    var o = r.RTCPeerConnection.prototype.setRemoteDescription;
    r.RTCPeerConnection.prototype.setRemoteDescription = function() {
      var c = this;
      return this._onaddstreampoly || this.addEventListener("track", this._onaddstreampoly = function(l) {
        l.streams.forEach(function(h) {
          if (c._remoteStreams || (c._remoteStreams = []), !(c._remoteStreams.indexOf(h) >= 0)) {
            c._remoteStreams.push(h);
            var v = new Event("addstream");
            v.stream = h, c.dispatchEvent(v);
          }
        });
      }), o.apply(c, arguments);
    };
  }
}
function Ti(r) {
  if (!(pe(r) !== "object" || !r.RTCPeerConnection)) {
    var o = r.RTCPeerConnection.prototype, i = o.createOffer, c = o.createAnswer, l = o.setLocalDescription, h = o.setRemoteDescription, v = o.addIceCandidate;
    o.createOffer = function(p, _) {
      var S = arguments.length >= 2 ? arguments[2] : arguments[0], C = i.apply(this, [S]);
      return _ ? (C.then(p, _), Promise.resolve()) : C;
    }, o.createAnswer = function(p, _) {
      var S = arguments.length >= 2 ? arguments[2] : arguments[0], C = c.apply(this, [S]);
      return _ ? (C.then(p, _), Promise.resolve()) : C;
    };
    var g = function(p, _, S) {
      var C = l.apply(this, [p]);
      return S ? (C.then(_, S), Promise.resolve()) : C;
    };
    o.setLocalDescription = g, g = function(p, _, S) {
      var C = h.apply(this, [p]);
      return S ? (C.then(_, S), Promise.resolve()) : C;
    }, o.setRemoteDescription = g, g = function(p, _, S) {
      var C = v.apply(this, [p]);
      return S ? (C.then(_, S), Promise.resolve()) : C;
    }, o.addIceCandidate = g;
  }
}
function Ei(r) {
  var o = r && r.navigator;
  if (o.mediaDevices && o.mediaDevices.getUserMedia) {
    var i = o.mediaDevices, c = i.getUserMedia.bind(i);
    o.mediaDevices.getUserMedia = function(l) {
      return c(en(l));
    };
  }
  !o.getUserMedia && o.mediaDevices && o.mediaDevices.getUserMedia && (o.getUserMedia = (function(h, v, g) {
    o.mediaDevices.getUserMedia(h).then(v, g);
  }).bind(o));
}
function en(r) {
  return r && r.video !== void 0 ? Object.assign({}, r, {
    video: Zr.compactObject(r.video)
  }) : r;
}
function Oi(r) {
  if (r.RTCPeerConnection) {
    var o = r.RTCPeerConnection;
    r.RTCPeerConnection = function(c, l) {
      if (c && c.iceServers) {
        for (var h = [], v = 0; v < c.iceServers.length; v++) {
          var g = c.iceServers[v];
          g.urls === void 0 && g.url ? (Zr.deprecated("RTCIceServer.url", "RTCIceServer.urls"), g = JSON.parse(JSON.stringify(g)), g.urls = g.url, delete g.url, h.push(g)) : h.push(c.iceServers[v]);
        }
        c.iceServers = h;
      }
      return new o(c, l);
    }, r.RTCPeerConnection.prototype = o.prototype, "generateCertificate" in o && Object.defineProperty(r.RTCPeerConnection, "generateCertificate", {
      get: function() {
        return o.generateCertificate;
      }
    });
  }
}
function Mi(r) {
  pe(r) === "object" && r.RTCTrackEvent && "receiver" in r.RTCTrackEvent.prototype && !("transceiver" in r.RTCTrackEvent.prototype) && Object.defineProperty(r.RTCTrackEvent.prototype, "transceiver", {
    get: function() {
      return {
        receiver: this.receiver
      };
    }
  });
}
function Ai(r) {
  var o = r.RTCPeerConnection.prototype.createOffer;
  r.RTCPeerConnection.prototype.createOffer = function(c) {
    if (c) {
      typeof c.offerToReceiveAudio < "u" && (c.offerToReceiveAudio = !!c.offerToReceiveAudio);
      var l = this.getTransceivers().find(function(v) {
        return v.receiver.track.kind === "audio";
      });
      c.offerToReceiveAudio === !1 && l ? l.direction === "sendrecv" ? l.setDirection ? l.setDirection("sendonly") : l.direction = "sendonly" : l.direction === "recvonly" && (l.setDirection ? l.setDirection("inactive") : l.direction = "inactive") : c.offerToReceiveAudio === !0 && !l && this.addTransceiver("audio", {
        direction: "recvonly"
      }), typeof c.offerToReceiveVideo < "u" && (c.offerToReceiveVideo = !!c.offerToReceiveVideo);
      var h = this.getTransceivers().find(function(v) {
        return v.receiver.track.kind === "video";
      });
      c.offerToReceiveVideo === !1 && h ? h.direction === "sendrecv" ? h.setDirection ? h.setDirection("sendonly") : h.direction = "sendonly" : h.direction === "recvonly" && (h.setDirection ? h.setDirection("inactive") : h.direction = "inactive") : c.offerToReceiveVideo === !0 && !h && this.addTransceiver("video", {
        direction: "recvonly"
      });
    }
    return o.apply(this, arguments);
  };
}
function Di(r) {
  pe(r) !== "object" || r.AudioContext || (r.AudioContext = r.webkitAudioContext);
}
const Ri = (r) => {
  let o = !1, i;
  return (...c) => (o || (i = r(c), o = !0), i);
};
function ue(r, o) {
  if (r === !1)
    throw new Error(o != null ? o : "assertion failure");
}
const xi = Ri(() => {
  const r = ni(window);
  switch (r.browser) {
    case "chrome":
      pi(window, r);
      break;
    case "firefox":
      gi(window, r);
      break;
    case "safari":
      $i(window, r);
      break;
    default:
      throw new Vr();
  }
});
let Pe = Promise.resolve({ type: "stop", data: {} });
async function Or(r, o, i) {
  var g, b, p;
  if (window.isSecureContext !== !0)
    throw new Xo();
  if (((g = navigator == null ? void 0 : navigator.mediaDevices) == null ? void 0 : g.getUserMedia) === void 0)
    throw new Vr();
  xi();
  const c = await navigator.mediaDevices.getUserMedia({
    audio: !1,
    video: o
  });
  r.srcObject !== void 0 ? r.srcObject = c : r.mozSrcObject !== void 0 ? r.mozSrcObject = c : window.URL.createObjectURL ? r.src = window.URL.createObjectURL(c) : window.webkitURL ? r.src = window.webkitURL.createObjectURL(c) : r.src = c.id, r.play(), await Promise.race([
    Vt(r, "loadeddata"),
    // On iOS devices in PWA mode, QrcodeStream works initially, but after
    // killing and restarting the PWA, all video elements fail to load camera
    // streams and never emit the `loadeddata` event. Looks like this is
    // related to a WebKit issue (see #298). No workarounds at the moment.
    // To at least detect this situation, we throw an error if the event
    // has not been emitted after a 3 second timeout.
    Pr(3e3).then(() => {
      throw new Zo();
    })
  ]), await Pr(500);
  const [l] = c.getVideoTracks(), h = (p = (b = l == null ? void 0 : l.getCapabilities) == null ? void 0 : b.call(l)) != null ? p : {};
  let v = !1;
  return i && h.torch && (await l.applyConstraints({ advanced: [{ torch: !0 }] }), v = !0), {
    type: "start",
    data: {
      videoEl: r,
      stream: c,
      capabilities: h,
      constraints: o,
      isTorchOn: v
    }
  };
}
async function ki(r, {
  constraints: o,
  torch: i,
  restart: c = !1
}) {
  Pe = Pe.then((h) => {
    if (h.type === "start") {
      const {
        data: {
          videoEl: v,
          stream: g,
          constraints: b,
          isTorchOn: p
        }
      } = h;
      return !c && r === v && o === b && i === p ? h : tn(v, g, p).then(
        () => Or(r, o, i)
      );
    }
    return Or(r, o, i);
  });
  const l = await Pe;
  if (l.type === "stop")
    throw new Error("Something went wrong with the camera task queue (start task).");
  return l.data.capabilities;
}
async function tn(r, o, i) {
  r.src = "", r.srcObject = null, r.load(), await Vt(r, "error");
  for (const c of o.getTracks())
    i != null || await c.applyConstraints({ advanced: [{ torch: !1 }] }), o.removeTrack(c), c.stop();
  return {
    type: "stop",
    data: {}
  };
}
async function at() {
  if (Pe = Pe.then((o) => {
    if (o.type === "stop")
      return o;
    const {
      data: { videoEl: i, stream: c, isTorchOn: l }
    } = o;
    return tn(i, c, l);
  }), (await Pe).type === "start")
    throw new Error("Something went wrong with the camera task queue (stop task).");
}
const Ii = /* @__PURE__ */ jt({
  __name: "QrcodeStream",
  props: {
    constraints: {
      type: Object,
      default() {
        return { facingMode: "environment" };
      }
    },
    formats: {
      type: Array,
      default: () => ["qr_code"]
    },
    paused: {
      type: Boolean,
      default: !1
    },
    torch: {
      type: Boolean,
      default: !1
    },
    track: {
      type: Function
    }
  },
  emits: ["detect", "camera-on", "camera-off", "error"],
  setup(r, { emit: o }) {
    const i = r, c = o, l = We(), h = We(), v = We(), g = We(!1), b = We(!1);
    po(() => {
      b.value = !0;
    }), mo(() => {
      at();
    });
    const p = It(() => ({
      torch: i.torch,
      constraints: i.constraints,
      shouldStream: b.value && !i.paused
    }));
    Ft(
      p,
      async (k) => {
        const U = v.value;
        ue(
          U !== void 0,
          "cameraSettings watcher should never be triggered when component is not mounted. Thus video element should always be defined."
        );
        const A = l.value;
        ue(
          A !== void 0,
          "cameraSettings watcher should never be triggered when component is not mounted. Thus canvas should always be defined."
        );
        const R = A.getContext("2d");
        if (ue(R !== null, "if cavnas is defined, canvas 2d context should also be non-null"), k.shouldStream) {
          at(), g.value = !1;
          try {
            const ae = await ki(U, k);
            b.value ? (g.value = !0, c("camera-on", ae)) : await at();
          } catch (ae) {
            c("error", ae);
          }
        } else
          A.width = U.videoWidth, A.height = U.videoHeight, R.drawImage(U, 0, 0, U.videoWidth, U.videoHeight), at(), g.value = !1, c("camera-off");
      },
      { deep: !0 }
    );
    const { formats: _ } = vo(i);
    Ft(_, (k) => {
      b.value && Ko(k);
    });
    const S = It(() => p.value.shouldStream && g.value);
    Ft(S, (k) => {
      if (k) {
        ue(
          l.value !== void 0,
          "shouldScan watcher should only be triggered when component is mounted. Thus pause frame canvas is defined"
        ), C(l.value), ue(
          h.value !== void 0,
          "shouldScan watcher should only be triggered when component is mounted. Thus tracking canvas is defined"
        ), C(h.value);
        const U = () => i.track === void 0 ? 500 : 40;
        ue(
          v.value !== void 0,
          "shouldScan watcher should only be triggered when component is mounted. Thus video element is defined"
        ), ei(v.value, {
          detectHandler: (A) => c("detect", A),
          formats: i.formats,
          locateHandler: W,
          minDelay: U()
        });
      }
    });
    const C = (k) => {
      const U = k.getContext("2d");
      ue(U !== null, "canvas 2d context should always be non-null"), U.clearRect(0, 0, k.width, k.height);
    }, W = (k) => {
      const U = h.value;
      ue(
        U !== void 0,
        "onLocate handler should only be called when component is mounted. Thus tracking canvas is always defined."
      );
      const A = v.value;
      if (ue(
        A !== void 0,
        "onLocate handler should only be called when component is mounted. Thus video element is always defined."
      ), k.length === 0 || i.track === void 0)
        C(U);
      else {
        const R = A.offsetWidth, ae = A.offsetHeight, ge = A.videoWidth, we = A.videoHeight, Ee = Math.max(R / ge, ae / we), Oe = ge * Ee, Me = we * Ee, lt = Oe / ge, dt = Me / we, ft = (R - Oe) / 2, ht = (ae - Me) / 2, Ae = ({ x: le, y: ee }) => ({
          x: Math.floor(le * lt),
          y: Math.floor(ee * dt)
        }), Le = ({ x: le, y: ee }) => ({
          x: Math.floor(le + ft),
          y: Math.floor(ee + ht)
        }), oe = k.map((le) => {
          const { boundingBox: ee, cornerPoints: be } = le, { x: pt, y: He } = Le(
            Ae({
              x: ee.x,
              y: ee.y
            })
          ), { x: de, y: Be } = Ae({
            x: ee.width,
            y: ee.height
          });
          return {
            ...le,
            cornerPoints: be.map((mt) => Le(Ae(mt))),
            boundingBox: DOMRectReadOnly.fromRect({ x: pt, y: He, width: de, height: Be })
          };
        });
        U.width = A.offsetWidth, U.height = A.offsetHeight;
        const me = U.getContext("2d");
        i.track(oe, me);
      }
    }, F = {
      width: "100%",
      height: "100%",
      position: "relative",
      // notice that we use z-index only once for the wrapper div.
      // If z-index is not defined, elements are stacked in the order they appear in the DOM.
      // The first element is at the very bottom and subsequent elements are added on top.
      "z-index": "0"
    }, j = {
      width: "100%",
      height: "100%",
      position: "absolute",
      top: "0",
      left: "0"
    }, M = {
      width: "100%",
      height: "100%",
      "object-fit": "cover"
    }, x = It(() => S.value ? M : {
      ...M,
      visibility: "hidden",
      position: "absolute"
    });
    return (k, U) => (Lt(), Ht("div", { style: F }, [
      rt("video", {
        ref_key: "videoRef",
        ref: v,
        style: yo(x.value),
        autoplay: "",
        muted: "",
        playsinline: ""
      }, null, 4),
      go(rt("canvas", {
        id: "qrcode-stream-pause-frame",
        ref_key: "pauseFrameRef",
        ref: l,
        style: M
      }, null, 512), [
        [wo, !S.value]
      ]),
      rt("canvas", {
        id: "qrcode-stream-tracking-layer",
        ref_key: "trackingLayerRef",
        ref: h,
        style: j
      }, null, 512),
      rt("div", { style: j }, [
        Mr(k.$slots, "default")
      ])
    ]));
  }
}), Fi = /* @__PURE__ */ jt({
  __name: "QrcodeCapture",
  props: {
    formats: {
      type: Array,
      default: () => ["qr_code"]
    }
  },
  emits: ["detect"],
  setup(r, { emit: o }) {
    const i = r, c = o, l = (h) => {
      if (!(!(h.target instanceof HTMLInputElement) || !h.target.files))
        for (const v of Array.from(h.target.files))
          zr(v, i.formats).then((g) => {
            c("detect", g);
          });
    };
    return (h, v) => (Lt(), Ht("input", {
      onChange: l,
      type: "file",
      name: "image",
      accept: "image/*",
      capture: "environment",
      multiple: ""
    }, null, 32));
  }
}), Ui = /* @__PURE__ */ jt({
  __name: "QrcodeDropZone",
  props: {
    formats: {
      type: Array,
      default: () => ["qr_code"]
    }
  },
  emits: ["detect", "dragover", "error"],
  setup(r, { emit: o }) {
    const i = r, c = o, l = async (g) => {
      try {
        const b = await g;
        c("detect", b);
      } catch (b) {
        c("error", b);
      }
    }, h = (g) => {
      c("dragover", g);
    }, v = ({ dataTransfer: g }) => {
      if (!g)
        return;
      h(!1);
      const b = [...Array.from(g.files)], p = g.getData("text/uri-list");
      b.forEach((_) => {
        l(zr(_));
      }), p !== "" && l(ri(p, i.formats));
    };
    return (g, b) => (Lt(), Ht("div", {
      onDrop: nt(v, ["prevent", "stop"]),
      onDragenter: b[0] || (b[0] = nt((p) => h(!0), ["prevent", "stop"])),
      onDragleave: b[1] || (b[1] = nt((p) => h(!1), ["prevent", "stop"])),
      onDragover: b[2] || (b[2] = nt(() => {
      }, ["prevent", "stop"]))
    }, [
      Mr(g.$slots, "default")
    ], 32));
  }
});
function Wi(r) {
  r.component("qrcode-stream", Ii), r.component("qrcode-capture", Fi), r.component("qrcode-drop-zone", Ui);
}
const Hi = { install: Wi };
export {
  Fi as QrcodeCapture,
  Ui as QrcodeDropZone,
  Ii as QrcodeStream,
  Hi as VueQrcodeReader,
  Wi as install,
  Li as setZXingModuleOverrides
};
